/*
 * This file is part of xsoundtrack - a sound tracker for Linux.
 * Sed - july august 1998.
 * This is total free software.
 *-------------------------------------
 * the sub windows of the xm-interface, functions to handle that.
 */

#include "sub_interface.h"

#include <X11/Xlib.h>
#include <X11/keysym.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#include "interface.h"
#include "xm.h"
#include "screen.h"
#include "mixer.h"
#include "keyboard_definition.h"
#include "instrument.h"
#include "sample.h"
#include "file_selector.h"

#include <stdio.h>
void enter_subwin_0(INTERFACE *i, XM *xm)
{
}

void enter_subwin_1(INTERFACE *i, XM *xm)
{
}

void enter_subwin_2(INTERFACE *i, XM *xm)
{
  switch(xm->cur_pos_2) {
    case 0 :
      draw_rectangle(i->X_ecran, xm->pixmap, i->context, XDD+9+6*7+5-2, 1+5+4-2, 16, 16, 1, 0);
      draw_rectangle(i->X_ecran, xm->window, i->context, XDD+9+6*7+5-2, 1+5+4-2, 16, 16, 1, 0);
      break;
    case 1 :
      draw_rectangle(i->X_ecran, xm->pixmap, i->context, XDD+9+6*7+5-2, 1+5+4+13+3-2, 16, 16, 1, 0);
      draw_rectangle(i->X_ecran, xm->window, i->context, XDD+9+6*7+5-2, 1+5+4+13+3-2, 16, 16, 1, 0);
      break;
    case 2 :
      draw_rectangle(i->X_ecran, xm->pixmap, i->context, XDD+9+6*7+5-2, 1+5+4+13+3+13+6-2, 16, 16, 1, 0);
      draw_rectangle(i->X_ecran, xm->window, i->context, XDD+9+6*7+5-2, 1+5+4+13+3+13+6-2, 16, 16, 1, 0);
      break;
    case 3 :
      draw_rectangle(i->X_ecran, xm->pixmap, i->context, XDD+9+6*7+5-2, 1+5+4+13+3+13+6+13+3-2, 16, 16, 1, 0);
      draw_rectangle(i->X_ecran, xm->window, i->context, XDD+9+6*7+5-2, 1+5+4+13+3+13+6+13+3-2, 16, 16, 1, 0);
      break;
  }
}

void enter_subwin_3(INTERFACE *i, XM *xm)
{
  int a=strlen(xm->module_name);
  draw_line(i->X_ecran, xm->pixmap, i->context, 265-5-14+12+6+a*6, 29+2, 265-5-14+12+6+a*6, 29-8, 0);
  draw_line(i->X_ecran, xm->window, i->context, 265-5-14+12+6+a*6, 29+2, 265-5-14+12+6+a*6, 29-8, 0);
}

void enter_subwin_4(INTERFACE *i, XM *xm)
{
  int x, y;
  switch(xm->cur_pos_4) {
    case 0 :
      x=402-3; y=11+1;
      break;
    case 3 :
      x=402-3; y=97+1;
      break;
    case 1 :
      x=400-6+30-18; y=44+4;
      break;
    case 2 :
      x=400-6+30-18; y=68-4;
      break;
    case 4 :
      x=400-6+30-18; y=39+90-5-1+13;
      break;
    case 5 :
      x=400-6+30-18; y=61+90-5+1+5;
      break;
  }
  draw_rectangle(i->X_ecran, xm->pixmap, i->context, x-2, y-2, 16, 16, 1, 0);
  draw_rectangle(i->X_ecran, xm->window, i->context, x-2, y-2, 16, 16, 1, 0);
}

void enter_subwin_5(INTERFACE *i, XM *xm)
{
  int a=4;
  instrument *inst;

  /* we gonna use the interface_subwin_5 for the arrow subwin (4), and it will call this.
   * So, we make a little check.
   */
  if (xm->subwindow!=5)
    return;

  inst=xm->instruments[xm->start_5+xm->cur_pos_5];
  if (inst)
    a+=strlen(inst->name);
  draw_line(i->X_ecran, xm->pixmap, i->context, 138+294+a*6, 22+xm->cur_pos_5*12+2,
	    138+294+a*6, 22+xm->cur_pos_5*12-8, 0);
  draw_line(i->X_ecran, xm->window, i->context, 138+294+a*6, 22+xm->cur_pos_5*12+2,
	    138+294+a*6, 22+xm->cur_pos_5*12-8, 0);
}

void enter_subwin_6(INTERFACE *i, XM *xm)
{
  int a=4;
  instrument *inst;

  /* we gonna use the interface_subwin_5 for the arrow subwin (4), and it will call this.
   * So, we make a little check.
   */
  if (xm->subwindow!=6)
    return;

  inst=xm->instruments[xm->start_5+xm->cur_pos_5];
  if (inst)
    a+=strlen(inst->sample_headers[xm->start_6+xm->cur_pos_6].sample_name);
  draw_line(i->X_ecran, xm->pixmap, i->context, 138+294+a*6, 10+20+8*12+10+xm->cur_pos_6*12+2,
	    138+294+a*6, 10+20+8*12+10+xm->cur_pos_6*12-8, 0);
  draw_line(i->X_ecran, xm->window, i->context, 138+294+a*6, 10+20+8*12+10+xm->cur_pos_6*12+2,
	    138+294+a*6, 10+20+8*12+10+xm->cur_pos_6*12-8, 0);
}

void enter_subwin_7(INTERFACE *i, XM *xm)
{
  if (xm->cur_pos_7==0)
    draw_rectangle(i->X_ecran, xm->pixmap, i->context, 5+6*18-5-2, 79+6+2-2, 13, 13, 1, 0),
    draw_rectangle(i->X_ecran, xm->window, i->context, 5+6*18-5-2, 79+6+2-2, 13, 13, 1, 0);
  else
    draw_rectangle(i->X_ecran, xm->pixmap, i->context, 5+6*29-5-2, 79+6+2-2, 13, 13, 1, 0),
    draw_rectangle(i->X_ecran, xm->window, i->context, 5+6*29-5-2, 79+6+2-2, 13, 13, 1, 0);
}

void enter_subwin_8(INTERFACE *i, XM *xm)
{
  void up_or_down_xm(INTERFACE *, XM *, Window, int);
  xm->mode=MOVING;
  if (!init_sample_interface(i, xm)) {
    fprintf(stderr, "sub_interface.enter_subwin_8 error with init_sample_interface\n");
  }
  up_or_down_xm(i, xm, xm->subwindow, UP_3D);
}

void draw_pos_9(INTERFACE *i, XM *xm)
{
  /* not very efficient, but not very used anyway, so... (go read draw_pattern and cry) */
  draw_box(i->X_ecran, xm->pixmap, i->context, XS9+4, YS9+4, 100-6*2-8, 15, xm->cur_pos_9==0?LIGHTBLUE:GREY);
  draw_box(i->X_ecran, xm->pixmap, i->context, XS9+4, YS9+4+15, 100-6*2-8, 15, xm->cur_pos_9==1?LIGHTBLUE:GREY);
  draw_box(i->X_ecran, xm->pixmap, i->context, XS9+4, YS9+4+15*2, 100-6*2-8, 15, xm->cur_pos_9==2?LIGHTBLUE:GREY);
  draw_string(i->X_ecran, xm->pixmap, i->context, XS9+8, YS9+8+6, "Save", i->little, BLACK);
  draw_string(i->X_ecran, xm->pixmap, i->context, XS9+8, YS9+8+6+15, "Save as...", i->little, BLACK);
  draw_string(i->X_ecran, xm->pixmap, i->context, XS9+8, YS9+8+6+15*2, "Dump to wav", i->little, BLACK);
  XCopyArea(i->X_ecran, xm->pixmap, xm->window, i->context, XS9, YS9, 100-6*2, 15*3+8, XS9, YS9);
}

void enter_subwin_9(INTERFACE *i, XM *xm)
{
  void around_xm(INTERFACE *, XM *, Window, int);
  around_xm(i, xm, xm->subwindow, OUT);
  draw_3d_box(i->X_ecran, xm->pixmap, i->context, XS9, YS9, 100-6*2, 15*3+8, GREY, UP_3D);
  xm->cur_pos_9=0;
  draw_pos_9(i, xm);
}

void enter_subwin_10(INTERFACE *i, XM *xm)
{
  void up_or_down_xm(INTERFACE *, XM *, Window, int);
  xm->mode=MOVING;
  if (!init_instrument_interface(i, xm)) {
    fprintf(stderr, "sub_interface.enter_subwin_10 error with init_instrument_interface\n");
  }
  up_or_down_xm(i, xm, xm->subwindow, UP_3D);
}

void enter_subwin_11(INTERFACE *i, XM *xm)
{
  void put_name_xm(INTERFACE *, XM *);
  void put_name_inst(INTERFACE *, XM *, instrument *);
  void put_name_sample(INTERFACE *, XM *, instrument *, sample *);
  int a;
  /* we close, so we free the module, and destroy all windows associated to it */
  /* first, destroy the window */
  XDestroyWindow(i->X_ecran, xm->window);
  XFreePixmap(i->X_ecran, xm->pixmap);
  /* then run through all the instruments and samples, and destroy the windows that are shown */
  for (a=0; a<128; a++) {
    int j;
    instrument *inst=xm->instruments[a];
    if (!inst)
      continue;
    if (inst->is_shown) {
      XDestroyWindow(i->X_ecran, inst->window);
      XFreePixmap(i->X_ecran, inst->pixmap);
    }
    /* now, run through its samples */
    for (j=0; j<16; j++) {
      sample *samp=&inst->sample_headers[j];
      if (samp->is_shown) {
	XDestroyWindow(i->X_ecran, samp->window);
	XFreePixmap(i->X_ecran, samp->pixmap);
      }
    }
  }
  /* we gotta check if this xm is the current xm or not */
  if (i->current_xm==xm)
    i->current_xm=(XM *)0;
  /* now, we take it away from the module-list */
  /* we don't test the free and the realloc, it grows down, should be ok (but it's bad, should go see the
   * source to know if it's absolutly correct)
   */
  if (i->nb_xms==1) {
    /* it's the last, we simply free it */
    free(i->xms);
    i->xms=(XM **)0;
  } else {
    int j;
    int xn;
    for (xn=0; ;xn++)
      if (xm==i->xms[xn])
	break;
    for (j=xn+1; j<i->nb_xms; j++)
      i->xms[j-1]=i->xms[j];
    i->xms=realloc(i->xms, (i->nb_xms-1)*sizeof(XM *));
  }
  i->nb_xms--;
  /* now, we simply free it. */
  if (xm->file_name)
    free(xm->file_name);
  free_xm(xm);
  /* we've now got to put the name of all the windows (might have changed) */
  for (a=0; a<i->nb_xms; a++) {
    int b;
    XM *xm=i->xms[a];
    /* the xm is shown */
    put_name_xm(i, xm);
    /* see its instruments */
    for (b=0; b<128; b++) {
      int c;
      instrument *inst=xm->instruments[b];
      if (!inst)
	continue;
      if (inst->is_shown)
	put_name_inst(i, xm, inst);
      /* and the samples of the instrument */
      for (c=0; c<16; c++) {
	sample *samp=&inst->sample_headers[c];
	if (samp->is_shown)
	  put_name_sample(i, xm, inst, samp);
      }
    }
  }
}

void enter_subwin_12(INTERFACE *i, XM *xm)
{
}

int sub_13[8][2]={
  {NNX+252+7*6+4+6, 52+4},
  {NNX+252+7*6+4, 52+4+11*2},
  {NNX+252+7*6+4, 52+4+11*2+13+3},
  {NNX+252+35-4+7*6-2, 137+41-25+16-12-10-3-40},
  {NNX+252+35-4+7*6-2, 137+41-25+16-12-10+13-40},
  {NNX+252+7*6+4+6, 51+11*8-13},
  {NNX+252+35-4+7*6-2, 137+41-25+16-12-10-3},
  {NNX+252+35-4+7*6-2, 137+41-25+16-12-10+13}
};

void enter_subwin_13(INTERFACE *i, XM *xm)
{
  int x=sub_13[xm->cur_pos_13][0], y=sub_13[xm->cur_pos_13][1];
  draw_rectangle(i->X_ecran, xm->pixmap, i->context, x-2, y-2, 16, 16, 1, 0);
  draw_rectangle(i->X_ecran, xm->window, i->context, x-2, y-2, 16, 16, 1, 0);
}

int sub_14[4][2]={
  {ADX+9+6*9+5, ADY+1+5+4},
  {ADX+9+6*9+5, ADY+1+5+4+13+3},
  {ADX+9+6*9+5, ADY+1+5+4+13+3+13+6-1},
  {ADX+9+6*9+5, ADY+1+5+4+13+3+13+6+13+3-1},
};

void enter_subwin_14(INTERFACE *i, XM *xm)
{
  int x=sub_14[xm->cur_pos_14][0], y=sub_14[xm->cur_pos_14][1];
  draw_rectangle(i->X_ecran, xm->pixmap, i->context, x-2, y-2, 16, 16, 1, 0);
  draw_rectangle(i->X_ecran, xm->window, i->context, x-2, y-2, 16, 16, 1, 0);
}

void exit_subwin_0(INTERFACE *i, XM *xm)
{
}

void exit_subwin_1(INTERFACE *i, XM *xm)
{
}

void exit_subwin_2(INTERFACE *i, XM *xm)
{
  switch(xm->cur_pos_2) {
    case 0 :
      draw_rectangle(i->X_ecran, xm->pixmap, i->context, XDD+9+6*7+5-2, 1+5+4-2, 16, 16, 1, 6);
      draw_rectangle(i->X_ecran, xm->window, i->context, XDD+9+6*7+5-2, 1+5+4-2, 16, 16, 1, 6);
      break;
    case 1 :
      draw_rectangle(i->X_ecran, xm->pixmap, i->context, XDD+9+6*7+5-2, 1+5+4+13+3-2, 16, 16, 1, 6);
      draw_rectangle(i->X_ecran, xm->window, i->context, XDD+9+6*7+5-2, 1+5+4+13+3-2, 16, 16, 1, 6);
      break;
    case 2 :
      draw_rectangle(i->X_ecran, xm->pixmap, i->context, XDD+9+6*7+5-2, 1+5+4+13+3+13+6-2, 16, 16, 1, 6);
      draw_rectangle(i->X_ecran, xm->window, i->context, XDD+9+6*7+5-2, 1+5+4+13+3+13+6-2, 16, 16, 1, 6);
      break;
    case 3 :
      draw_rectangle(i->X_ecran, xm->pixmap, i->context, XDD+9+6*7+5-2, 1+5+4+13+3+13+6+13+3-2, 16, 16, 1, 6);
      draw_rectangle(i->X_ecran, xm->window, i->context, XDD+9+6*7+5-2, 1+5+4+13+3+13+6+13+3-2, 16, 16, 1, 6);
      break;
  }
}

void exit_subwin_3(INTERFACE *i, XM *xm)
{
  int a=strlen(xm->module_name);
  draw_line(i->X_ecran, xm->pixmap, i->context, 265-5-14+12+6+a*6, 29+2, 265-5-14+12+6+a*6, 29-8, 3);
  draw_line(i->X_ecran, xm->window, i->context, 265-5-14+12+6+a*6, 29+2, 265-5-14+12+6+a*6, 29-8, 3);
}

void exit_subwin_4(INTERFACE *i, XM *xm)
{
  int x, y;
  switch(xm->cur_pos_4) {
    case 0 :
      x=402-3; y=11+1;
      break;
    case 3 :
      x=402-3; y=97+1;
      break;
    case 1 :
      x=400-6+30-18; y=44+4;
      break;
    case 2 :
      x=400-6+30-18; y=68-4;
      break;
    case 4 :
      x=400-6+30-18; y=39+90-5-1+13;
      break;
    case 5 :
      x=400-6+30-18; y=61+90-5+1+5;
      break;
  }
  draw_rectangle(i->X_ecran, xm->pixmap, i->context, x-2, y-2, 16, 16, 1, 6);
  draw_rectangle(i->X_ecran, xm->window, i->context, x-2, y-2, 16, 16, 1, 6);
}

void exit_subwin_5(INTERFACE *i, XM *xm)
{
  int a=4;
  instrument *inst;

  /* we gonna use the interface_subwin_5 for the arrow subwin (4), and it will call this.
   * So, we make a little check.
   */
  if (xm->subwindow!=5)
    return;

  inst=xm->instruments[xm->start_5+xm->cur_pos_5];
  if (inst)
    a+=strlen(inst->name);
  draw_line(i->X_ecran, xm->pixmap, i->context, 138+294+a*6, 22+xm->cur_pos_5*12+2,
	    138+294+a*6, 22+xm->cur_pos_5*12-8, 3);
  draw_line(i->X_ecran, xm->window, i->context, 138+294+a*6, 22+xm->cur_pos_5*12+2,
	    138+294+a*6, 22+xm->cur_pos_5*12-8, 3);
}

void exit_subwin_6(INTERFACE *i, XM *xm)
{
  int a=4;
  instrument *inst;

  /* we gonna use the interface_subwin_5 for the arrow subwin (4), and it will call this.
   * So, we make a little check.
   */
  if (xm->subwindow!=6)
    return;

  inst=xm->instruments[xm->start_5+xm->cur_pos_5];
  if (inst)
    a+=strlen(inst->sample_headers[xm->start_6+xm->cur_pos_6].sample_name);
  draw_line(i->X_ecran, xm->pixmap, i->context, 138+294+a*6, 10+20+8*12+10+xm->cur_pos_6*12+2,
	    138+294+a*6, 10+20+8*12+10+xm->cur_pos_6*12-8, 3);
  draw_line(i->X_ecran, xm->window, i->context, 138+294+a*6, 10+20+8*12+10+xm->cur_pos_6*12+2,
	    138+294+a*6, 10+20+8*12+10+xm->cur_pos_6*12-8, 3);
}

void exit_subwin_7(INTERFACE *i, XM *xm)
{
  if (xm->cur_pos_7==0)
    draw_rectangle(i->X_ecran, xm->pixmap, i->context, 5+6*18-5-2, 79+6+2-2, 13, 13, 1, 6),
    draw_rectangle(i->X_ecran, xm->window, i->context, 5+6*18-5-2, 79+6+2-2, 13, 13, 1, 6);
  else
    draw_rectangle(i->X_ecran, xm->pixmap, i->context, 5+6*29-5-2, 79+6+2-2, 13, 13, 1, 6),
    draw_rectangle(i->X_ecran, xm->window, i->context, 5+6*29-5-2, 79+6+2-2, 13, 13, 1, 6);
}

void exit_subwin_8(INTERFACE *i, XM *xm)
{
}

void exit_subwin_9(INTERFACE *i, XM *xm)
{
  void around_xm(INTERFACE *, XM *, Window, int);
  void draw_restart(INTERFACE *, XM *);
  void draw_nb_channels(INTERFACE *, XM *);
  void draw_restart_pos(INTERFACE *, XM *);
  around_xm(i, xm, xm->subwindow, IN);
  draw_restart(i, xm);
  draw_nb_channels(i, xm);
  draw_restart_pos(i, xm);
  XCopyArea(i->X_ecran, xm->pixmap, xm->window, i->context, ADX+5, ADY+5, 148-7*6-4, 74-1, ADX+5, ADY+5);
}

void exit_subwin_10(INTERFACE *i, XM *xm)
{
}

void exit_subwin_11(INTERFACE *i, XM *xm)
{
}

void exit_subwin_12(INTERFACE *i, XM *xm)
{
}

void exit_subwin_13(INTERFACE *i, XM *xm)
{
  int x=sub_13[xm->cur_pos_13][0], y=sub_13[xm->cur_pos_13][1];
  draw_rectangle(i->X_ecran, xm->pixmap, i->context, x-2, y-2, 16, 16, 1, 6);
  draw_rectangle(i->X_ecran, xm->window, i->context, x-2, y-2, 16, 16, 1, 6);
}

void exit_subwin_14(INTERFACE *i, XM *xm)
{
  int x=sub_14[xm->cur_pos_14][0], y=sub_14[xm->cur_pos_14][1];
  draw_rectangle(i->X_ecran, xm->pixmap, i->context, x-2, y-2, 16, 16, 1, 6);
  draw_rectangle(i->X_ecran, xm->window, i->context, x-2, y-2, 16, 16, 1, 6);
}

void draw_patterns_(INTERFACE *i, XM *xm)
{
  static int x_decalage[8]={0, 6*4, 6*4+6, 6*4+6*3, 6*4+6*4, 6*4+6*6, 6*4+6*7, 6*4+6*8};
  static int x_largeur[8]={6*3, 6, 6, 6, 6, 6, 6, 6};
  extern char *name_note[12];
  char s[2000];
  int io;
  note *n;
  int in;

  /* first version. Redraw everything (slow slow slow) */
  draw_box(i->X_ecran, xm->pixmap, i->context, 5+2, 150+2*16+2, 590-4, 245-2*16-4, 6);
  draw_box(i->X_ecran, xm->pixmap, i->context, 9, 144+7*18-14+2+2*9, 590-8, 16-4, 3);
  for (in=0; in<6; in++)
    draw_line(i->X_ecran, xm->pixmap, i->context, 27+in*16*6, 150+2*16+2, 27+in*16*6, 150+2*16+2+245-2*16-4, GREY+1),
    draw_line(i->X_ecran, xm->pixmap, i->context, 28+in*16*6, 150+2*16+2, 28+in*16*6, 150+2*16+2+245-2*16-4, GREY-1);
  for (in=0; in<5; in++)
    sprintf(s+in*16, "              %2d", in+xm->start_column_0+1);
  draw_string(i->X_ecran, xm->pixmap, i->context, 12+6*3-4, 162+2*16, s, i->little, RED);
  draw_box(i->X_ecran, xm->pixmap, i->context, 12+3*6+6*16*xm->cursor_column_0+x_decalage[xm->cur_pos_0],
	   144+7*18-14+2+2*9, x_largeur[xm->cur_pos_0], 16-4, YELLOW);
  for (in=0; in<16; in++) {
    if (in+xm->current_line-7>=xm->patterns_nb_rows[(int)xm->patterns_order[xm->current_pattern]])
      continue;
    if (in+xm->current_line-7<0)
      continue;

    sprintf(s, "%2.2X ", (unsigned char)(in+xm->current_line-7));
    n=xm->patterns[(int)xm->patterns_order[(int)xm->current_pattern]]+(in-7+xm->current_line)+
      (xm->start_column_0*xm->patterns_nb_rows[(int)xm->patterns_order[(int)xm->current_pattern]]);

    for (io=0; io<6; io++, n+=xm->patterns_nb_rows[(int)xm->patterns_order[(int)xm->current_pattern]]) {
      if (io>=xm->nb_channels)
	break;

      /* the note */
      if (n->note>96)
	sprintf(s+strlen(s), "--- ");
      else {
	int note=n->note%12;
	int octav=n->note/12;
	if (n->note==96)
	  sprintf(s+strlen(s), " =  ");
	else
	  sprintf(s+strlen(s), "%s%d ", name_note[note], octav);
      }
      /* the instrument */
      if (n->instrument==-1)
	sprintf(s+strlen(s), "   ");
      else
	sprintf(s+strlen(s), "%2.2X ", (unsigned char)n->instrument+1);
      /* the volume */
      if (n->volume==0)
	sprintf(s+strlen(s), "-- ");
      else {
	if ((unsigned char)n->volume<=0x50)
	  sprintf(s+strlen(s), "%2.2X ", (unsigned char)n->volume-0x10);
	else {
	  char m;
	  int v=n->volume&15;
	  switch((n->volume>>4)&15) {
	    case  6 : m='-'; break;
	    case  7 : m='+'; break;
	    case  8 : m='d'; break;
	    case  9 : m='u'; break;
	    case 10 : m='s'; break;
	    case 11 : m='v'; break;
	    case 12 : m='p'; break;
	    case 13 : m='l'; break;
	    case 14 : m='r'; break;
	    case 15 : m='m'; break;
	  }
	  sprintf(s+strlen(s), "%c%c ", m, v<10 ? v+'0' : v+'A'-10);
	}
      }
      /* the effect */
      if (n->effect_type==-1)
	sprintf(s+strlen(s), "---   ");
      else
	sprintf(s+strlen(s), "%c%2.2X   ", n->effect_type>9 ? n->effect_type-10+'A' : n->effect_type+'0',
		(unsigned char)n->effect_parameter);
    }
    draw_string(i->X_ecran, xm->pixmap, i->context, 12, 162+2*16+in*13, s, i->little, in==7 ? BLACK : BLUE);
  }
  /* verify if we are not in the current selection, and redraw things if yes */
  if (xm->current_selection_nb_lines>0 && xm->current_selection_pattern==xm->patterns_order[xm->current_pattern]) {
    int line, column;
    note *n;
    for (line=0; line<xm->current_selection_nb_lines; line++) {
      /* is line shown ? */
      if (line+xm->current_selection_start_line<xm->current_line-7)
	continue;
      if (line+xm->current_selection_start_line>xm->current_line+8)
	break;
      if (line+xm->current_selection_start_line>=xm->patterns_nb_rows[xm->current_selection_pattern])
	break;
      for (column=0; column<xm->current_selection_nb_columns; column++) {
	/* is column shown ? */
	if (column+xm->current_selection_start_column<xm->start_column_0)
	  continue;
	if (column+xm->current_selection_start_column>=xm->start_column_0+(xm->nb_channels>=6 ? 6 : xm->nb_channels))
	  break;
	/* let's red the note */
	n=xm->patterns[xm->current_selection_pattern];
	n+=(line+xm->current_selection_start_line);
	n+=(column+xm->current_selection_start_column)*(xm->patterns_nb_rows[xm->current_selection_pattern]);
	s[0]=0;
	/* the note */
	/* that code should be factorized, but i'm bored of it all */
	if (n->note>96)
	  sprintf(s+strlen(s), "--- ");
	else {
	  int note=n->note%12;
	  int octav=n->note/12;
	  if (n->note==96)
	    sprintf(s+strlen(s), " =  ");
	  else
	    sprintf(s+strlen(s), "%s%d ", name_note[note], octav);
	}
	/* the instrument */
	if (n->instrument==-1)
	  sprintf(s+strlen(s), "   ");
	else
	  sprintf(s+strlen(s), "%2.2X ", (unsigned char)n->instrument+1);
	/* the volume */
	if (n->volume==0)
	  sprintf(s+strlen(s), "-- ");
	else {
	  if ((unsigned char)n->volume<=0x50)
	    sprintf(s+strlen(s), "%2.2X ", (unsigned char)n->volume-0x10);
	  else {
	    char m;
	    int v=n->volume&15;
	    switch((n->volume>>4)&15) {
	      case  6 : m='-'; break;
	      case  7 : m='+'; break;
	      case  8 : m='d'; break;
	      case  9 : m='u'; break;
	      case 10 : m='s'; break;
	      case 11 : m='v'; break;
	      case 12 : m='p'; break;
	      case 13 : m='l'; break;
	      case 14 : m='r'; break;
	      case 15 : m='m'; break;
	    }
	    sprintf(s+strlen(s), "%c%c ", m, v<10 ? v+'0' : v+'A'-10);
	  }
	}
	/* the effect */
	if (n->effect_type==-1)
	  sprintf(s+strlen(s), "---   ");
	else
	  sprintf(s+strlen(s), "%c%2.2X   ", n->effect_type>9 ? n->effect_type-10+'A' : n->effect_type+'0',
		  (unsigned char)n->effect_parameter);
	draw_string(i->X_ecran, xm->pixmap, i->context,
		    12+3*6+(column+xm->current_selection_start_column-xm->start_column_0)*16*6,
		    162+2*16+(line+xm->current_selection_start_line-(xm->current_line-7))*13,
		    s, i->little, WHITE);
      }
    }
  }
  /* now, maybe some channels are closed, so cross them in red */
  for (io=0; io<6; io++) {
    int nb=xm->start_column_0+io;
    if (nb>=xm->nb_channels)
      break;
    if (xm->channels[nb].closed)
      draw_line(i->X_ecran, xm->pixmap, i->context, 12+3*6+io*16*6+4, 162+2*16, 12+3*6+io*16*6+15*6, 162+2*16+13*14, RED),
      draw_line(i->X_ecran, xm->pixmap, i->context, 12+3*6+io*16*6+4, 162+2*16+13*14, 12+3*6+io*16*6+15*6, 162+2*16, RED);
  }
}

void draw_patterns(INTERFACE *i, XM *xm)
{
  draw_patterns_(i, xm);
  XCopyArea(i->X_ecran, xm->pixmap, xm->window, i->context, 5+2, 150+2*16+2, 590-4, 245-2*16-4, 5+2, 150+2*16+2);
}

void draw_patterns_order(INTERFACE *i, XM *xm)
{
  int in;
  char res[10]; /* much enough, impossible to buffer overflow, don't even think of it */

  /* we could optimize those two boxes (the smallest possible) , but fuck it ! */
  draw_box(i->X_ecran, xm->pixmap, i->context, NNX+252, 52+2, 7*6, 11*8, 3);
  draw_box(i->X_ecran, xm->pixmap, i->context, NNX+254, 52+2+3*11, 7*6-4, 11, 6);
  for (in=0; in<8; in++) {
    if (in+xm->current_pattern-3>=xm->song_length)
      break;
    if (in+xm->current_pattern-3>=0) {
      sprintf(res, "%2.2X %2.2X", (unsigned char)(in+xm->current_pattern-3),
	      (unsigned char)(xm->patterns_order[in+xm->current_pattern-3]));
      draw_string(i->X_ecran, xm->pixmap, i->context, NNX+255+3, 52+11+in*11, res, i->little, 8);
    }
  }
  XCopyArea(i->X_ecran, xm->pixmap, xm->window, i->context, NNX+252, 52+2, 7*6, 11*8, NNX+252, 52+2);

  draw_box(i->X_ecran, xm->pixmap, i->context, NNX+252+35-4+7*6-4+13+5, 137+41-25+16-25+8-40, 7*6-4-16, 12, 3);
  sprintf(res, "%d", xm->patterns_nb_rows[(int)xm->patterns_order[(int)xm->current_pattern]]);
  draw_string(i->X_ecran, xm->pixmap, i->context, NNX+252+31+38+20+6*(3-strlen(res)), 137+25-40, res, i->little, 8);
  XCopyArea(i->X_ecran, xm->pixmap, xm->window, i->context, NNX+252+35-4+7*6-4+13+5, 137+41-25+16-25+8-40, 7*6-4-16, 12,
	    NNX+252+35-4+7*6-4+13+5, 137+41-25+16-25+8-40);
}

/* says if the effect exists */
int good_effect(int effect)
{
  /* 0, 1, .., a, b, .., f, g, h : ok */
  if (effect<=17)
    return 1;
  /* l, p, r, t, x */
  if (effect==21 || effect==25 || effect==27 || effect==29 || effect==33)
    return 1;
  return 0;
}

/* this function put the good values in the right place. */
/* from=0 : we just changed the effect type 1 = just changed the high effect param 2 = just changed low eff. par. */
/* return 0 if something was changed */
int verifie_note(note *n, int from)
{
  switch (n->effect_type) {
    default :
      break;
    case 10 :
    case 17 :
    case 25 :
      if ((n->effect_parameter&0x0f) && (n->effect_parameter&0xf0)) {
	n->effect_parameter=0;
	return 0;
      }
      break;
    case 14: {
      switch((unsigned char)n->effect_parameter>>4) {
        default :
	  break;
        case 0 :
	case 3 : {
	  int a=n->effect_parameter;
	  n->effect_parameter&=0xf1;
	  if (a!=n->effect_parameter && from==2)
	    return 0;
	  break;
	}
        case 4 :
        case 7 : {
	  int a=n->effect_parameter;
	  n->effect_parameter&=0xf7;;
	  if (n->effect_parameter&2)
	    n->effect_parameter&=0xfe;
	  if (a!=n->effect_parameter && from==2)
	    return 0;
	  break;
	}
        case 8 :
        case 15 :
	  n->effect_parameter=0;
	  return 0;
      }
      break;
    }
    case 16 :
      if ((unsigned char)n->effect_parameter>=0x40) {
	n->effect_parameter=0x40;
	//return 0;
      }
      break;
    case 33 : {
      int a=(unsigned char)(n->effect_parameter&0xf0)>>4;
      if (!a || a>2) {
	n->effect_parameter=0x10;
	return 0;
      }
      break;
    }
  }
  return 1;
}

/* this function will put the note value at the current place, correspondong to the KeySym */
/* return 1 if something changed 0 otherwise */
int insert_note_value(note *n, KeySym ks, int octave, XM *xm)
{
  int i;
  int note=-1;
  /* get the note value that correspond to the keysym */
  /* verifie in the down-keyboard */
  for (i=0; i<17; i++)
    if (keyboard_down[i]==ks) {
      note=i;
      break;
    }
  /* then the up keyboard */
  if (note==-1)
    for (i=0; i<20; i++)
      if (keyboard_up[i]==ks) {
	note=i+12;
	break;
      }
  /* maybe cut key */
  if (note==-1)
    if (ks==CUT_KEY) {
      n->note=96;
      return 1;
    }

  /* ok, so we have a note, get the good octave, and put it */
  if (note==-1)
    return 0;
  note+=octave*12;
  if (note>=96)
    return 0;
  if (note==n->note && n->instrument==xm->start_5+xm->cur_pos_5)
    return 0;
  n->note=note;
  /* put the instrument too */
  n->instrument=xm->start_5+xm->cur_pos_5;
  return 1;
}

/* when interface_subwin_0 calls this function, we have to put ks into the pattern, depending
 * of what it was (a note, an instrument, a volume, an effect)
 */
/* we take ks as a latin 1, and almost like in ascii (ie we do ks-'0' with ks in '0'..'9' to have the value).
 * bad bad bad, but i think it should be ok. If someone has troubles, let me know and i'll do it cleaner.
 */
void insert_something(INTERFACE *i, XM *xm, KeySym ks)
{
  note *n=xm->patterns[(int)xm->patterns_order[xm->current_pattern]]+
    xm->patterns_nb_rows[(int)xm->patterns_order[xm->current_pattern]]*(xm->start_column_0+xm->cursor_column_0)+
    xm->current_line;
  /* another pretty switch */
  switch (xm->cur_pos_0) {
    case 0 : /* note */
      if (insert_note_value(n, ks, xm->current_octave, xm)) {
	xm->current_line--;
	xm->speed=32768;
	xm->to_handle=new_line(xm);
	xm->new_line=xm->new_pattern=0;
	draw_patterns(i, xm);
      }
      break;
    case 1 : /* instrument high */
      if (ks>='0' && ks<='8') {
	int oi=n->instrument;
	n->instrument++;
	n->instrument&=0xf;
	n->instrument|=(unsigned char)(ks-'0')<<4;
	n->instrument--;
	if (n->instrument<-1)
	  n->instrument=127;
	if (oi!=n->instrument) {
	  xm->current_line--;
	  xm->speed=32768;
	  xm->to_handle=new_line(xm);
	  xm->new_line=xm->new_pattern=0;
	  draw_patterns(i, xm);
	}
	break;
      }
      break;
    case 2 : /* instrument low */
      if (ks>='0' && ks<='9') {
	int oi=n->instrument;
	n->instrument++;
	n->instrument&=0xf0;
	n->instrument|=(unsigned char)(ks-'0');
	n->instrument--;
	if (n->instrument<-1)
	  n->instrument=127;
	if (oi!=n->instrument) {
	  xm->current_line--;
	  xm->speed=32768;
	  xm->to_handle=new_line(xm);
	  xm->new_line=xm->new_pattern=0;
	  draw_patterns(i, xm);
	}
	break;
      }
      if (ks>='A' && ks<='F') {
	int oi=n->instrument;
	n->instrument++;
	n->instrument&=0xf0;
	n->instrument|=(unsigned char)(ks-'A'+10);
	n->instrument--;
	if (n->instrument<-1)
	  n->instrument=127;
	if (oi!=n->instrument) {
	  xm->current_line--;
	  xm->speed=32768;
	  xm->to_handle=new_line(xm);
	  xm->new_line=xm->new_pattern=0;
	  draw_patterns(i, xm);
	}
	break;
      }
      if (ks>='a' && ks<='f') {
	int oi=n->instrument;
	n->instrument++;
	n->instrument&=0xf0;
	n->instrument|=(unsigned char)(ks-'a'+10);
	n->instrument--;
	if (n->instrument<-1)
	  n->instrument=127;
	if (oi!=n->instrument) {
	  xm->current_line--;
	  xm->speed=32768;
	  xm->to_handle=new_line(xm);
	  xm->new_line=xm->new_pattern=0;
	  draw_patterns(i, xm);
	}
	break;
      }
      break;
    case 3 : /* volume high */
      if (ks>='0' && ks<='4') { /* set the volume */
	int oi=n->volume;
	n->volume&=0xf;
	n->volume|=(unsigned char)(ks-'0'+1)<<4;
	if (n->volume>0x50)
	  n->volume=0x50;
	if (oi!=n->volume) {
	  xm->current_line--;
	  xm->speed=32768;
	  xm->to_handle=new_line(xm);
	  xm->new_line=xm->new_pattern=0;
	  draw_patterns(i, xm);
	}
	break;
      }
      if (ks=='-') { /* volume slide down */
	int oi=n->volume;
	n->volume&=0xf;
	n->volume|=0x60;
	if (oi!=n->volume) {
	  xm->current_line--;
	  xm->speed=32768;
	  xm->to_handle=new_line(xm);
	  xm->new_line=xm->new_pattern=0;
	  draw_patterns(i, xm);
	}
	break;
      }
      if (ks=='+') { /* volume slide up */
	int oi=n->volume;
	n->volume&=0xf;
	n->volume|=0x70;
	if (oi!=n->volume) {
	  xm->current_line--;
	  xm->speed=32768;
	  xm->to_handle=new_line(xm);
	  xm->new_line=xm->new_pattern=0;
	  draw_patterns(i, xm);
	}
	break;
      }      
      if (ks=='d' || ks=='D') { /* fine volume slide down */
	int oi=n->volume;
	n->volume&=0xf;
	n->volume|=0x80;
	if (oi!=n->volume) {
	  xm->current_line--;
	  xm->speed=32768;
	  xm->to_handle=new_line(xm);
	  xm->new_line=xm->new_pattern=0;
	  draw_patterns(i, xm);
	}
	break;
      }      
      if (ks=='u' || ks=='U') { /* fine volume slide up */
	int oi=n->volume;
	n->volume&=0xf;
	n->volume|=0x90;
	if (oi!=n->volume) {
	  xm->current_line--;
	  xm->speed=32768;
	  xm->to_handle=new_line(xm);
	  xm->new_line=xm->new_pattern=0;
	  draw_patterns(i, xm);
	}
	break;
      }      
      if (ks=='s' || ks=='S') { /* set vibrato speed */
	int oi=n->volume;
	n->volume&=0xf;
	n->volume|=0xa0;
	if (oi!=n->volume) {
	  xm->current_line--;
	  xm->speed=32768;
	  xm->to_handle=new_line(xm);
	  xm->new_line=xm->new_pattern=0;
	  draw_patterns(i, xm);
	}
	break;
      }      
      if (ks=='v' || ks=='V') { /* vibrato */
	int oi=n->volume;
	n->volume&=0xf;
	n->volume|=0xb0;
	if (oi!=n->volume) {
	  xm->current_line--;
	  xm->speed=32768;
	  xm->to_handle=new_line(xm);
	  xm->new_line=xm->new_pattern=0;
	  draw_patterns(i, xm);
	}
	break;
      }      
      if (ks=='p' || ks=='P') { /* panning */
	int oi=n->volume;
	n->volume&=0xf;
	n->volume|=0xc0;
	if (oi!=n->volume) {
	  xm->current_line--;
	  xm->speed=32768;
	  xm->to_handle=new_line(xm);
	  xm->new_line=xm->new_pattern=0;
	  draw_patterns(i, xm);
	}
	break;
      }      
      if (ks=='l' || ks=='L') { /* panning slide left */
	int oi=n->volume;
	n->volume&=0xf;
	n->volume|=0xd0;
	if (oi!=n->volume) {
	  xm->current_line--;
	  xm->speed=32768;
	  xm->to_handle=new_line(xm);
	  xm->new_line=xm->new_pattern=0;
	  draw_patterns(i, xm);
	}
	break;
      }      
      if (ks=='r' || ks=='R') { /* panning slide right */
	int oi=n->volume;
	n->volume&=0xf;
	n->volume|=0xe0;
	if (oi!=n->volume) {
	  xm->current_line--;
	  xm->speed=32768;
	  xm->to_handle=new_line(xm);
	  xm->new_line=xm->new_pattern=0;
	  draw_patterns(i, xm);
	}
	break;
      }      
      if (ks=='m' || ks=='M') { /* tone portamento */
	int oi=n->volume;
	/* the & is not necessary. Big optimisation, huh ? */
	n->volume|=0xf0;
	if (oi!=n->volume) {
	  xm->current_line--;
	  xm->speed=32768;
	  xm->to_handle=new_line(xm);
	  xm->new_line=xm->new_pattern=0;
	  draw_patterns(i, xm);
	}
	break;
      }      
      break;
    case 4 : { /* volume low */
      int oi;
      if (!((ks>='0' && ks<='9') || (ks>='A' && ks<='F') || (ks>='a' && ks<='f')))
	break;
      if ((n->volume & 0xf0)==0x10 || n->volume==0) { /* low volume, have to take care not to be more than 0x40 */
	int oi=n->volume;
	n->volume&=0xf0;
	if (!n->volume)
	  n->volume=0x10;
	n->volume|=ks>='0' && ks<='9' ? ks-'0' : ks>='A' && ks<='F' ? ks-'A'+10 : ks-'a'+10;
	if (n->volume>0x50)
	  n->volume=0x50;
	if (oi!=n->volume) {
	  xm->current_line--;
	  xm->speed=32768;
	  xm->to_handle=new_line(xm);
	  xm->new_line=xm->new_pattern=0;
	  draw_patterns(i, xm);
	}
	break;
      }
      /* no care to take, let's handle it simply */
      oi=n->volume;
      n->volume&=0xf0;
      n->volume|=ks>='0' && ks<='9' ? ks-'0' : ks>='A' && ks<='F' ? ks-'A'+10 : ks-'a'+10;
      if (oi!=n->volume) {
	xm->current_line--;
	xm->speed=32768;
	xm->to_handle=new_line(xm);
	xm->new_line=xm->new_pattern=0;
	draw_patterns(i, xm);
      }
      break;
    }
    case 5 : { /* effect type */
      int oi;
      /* first version, will have to change it, to allow only valid values */
      if (!((ks>='0' && ks<='9') || (ks>='A' && ks<='Z') || (ks>='a' && ks<='z')))
	break;
      oi=n->effect_type;
      n->effect_type=ks>='0' && ks<='9' ? ks-'0' : ks>='A' && ks<='Z' ? ks-'A'+10 : ks-'a'+10;
      /* now, verify the parameter */
      if (!good_effect(n->effect_type)) {
	n->effect_type=oi;
	break;
      }
      if (oi==n->effect_type)
	break;
      verifie_note(n, 0);
      xm->current_line--;
      xm->speed=32768;
      xm->to_handle=new_line(xm);
      xm->new_line=xm->new_pattern=0;
      draw_patterns(i, xm);
      break;
    }
    case 6 : { /* effect parameter high */
      int oi;
      if (!((ks>='0' && ks<='9') || (ks>='A' && ks<='F') || (ks>='a' && ks<='f')))
	break;
      if (n->effect_type==-1) {
	XBell(i->X_ecran, 0);
	break;
      }
      oi=n->effect_parameter;
      n->effect_parameter&=0xf;
      n->effect_parameter|=(ks>='0' && ks<='9' ? ks-'0' : ks>='A' && ks<='F' ? ks-'A'+10 : ks-'a'+10)<<4;
      if (oi==n->effect_parameter)
	break;
      if (!verifie_note(n, 1)) {
	n->effect_parameter=oi;
	break;
      }
      xm->current_line--;
      xm->speed=32768;
      xm->to_handle=new_line(xm);
      xm->new_line=xm->new_pattern=0;
      draw_patterns(i, xm);
      break;
    }
    case 7 : { /* effect parameter low */
      int oi;
      if (!((ks>='0' && ks<='9') || (ks>='A' && ks<='F') || (ks>='a' && ks<='f')))
	break;
      if (n->effect_type==-1) {
	XBell(i->X_ecran, 0);
	break;
      }
      oi=n->effect_parameter;
      n->effect_parameter&=0xf0;
      n->effect_parameter|=ks>='0' && ks<='9' ? ks-'0' : ks>='A' && ks<='F' ? ks-'A'+10 : ks-'a'+10;
      if (oi==n->effect_parameter)
	break;
      if (!verifie_note(n, 2)) {
	n->effect_parameter=oi;
	break;
      }
      xm->current_line--;
      xm->speed=32768;
      xm->to_handle=new_line(xm);
      xm->new_line=xm->new_pattern=0;
      draw_patterns(i, xm);
      break;
    }
  }
}

/* for this subwindow, i absolutly need the shift+tab key, the shift + left, right, up, down key,
 * the control+inser, shift+inser, shift+del, control+del
 */
void interface_subwin_0(INTERFACE *i, XM *xm, KeySym ks)
{
  /* we want the status of the shift/control modifiers, so a global, because i don't want to change all. */
  /* this program is a real lameness... */
  extern unsigned int status;
  void interface_subwin_13(INTERFACE *, XM *, KeySym);

  if (status&ControlMask) {
    int old=xm->cur_pos_13;
    switch(ks) {
      case XK_plus : /* next pattern */
	xm->cur_pos_13=1;
	interface_subwin_13(i, xm, XK_Return);
	xm->cur_pos_13=old;
	return;
      case XK_minus : /* previous pattern */
	xm->cur_pos_13=2;
	interface_subwin_13(i, xm, XK_Return);
	xm->cur_pos_13=old;
	return;
      case XK_greater : /* pattern length ++ */
	xm->cur_pos_13=3;
	interface_subwin_13(i, xm, XK_Return);
	xm->cur_pos_13=old;
	return;
      case XK_less : /* pattern length -- */
	xm->cur_pos_13=4;
	interface_subwin_13(i, xm, XK_Return);
	xm->cur_pos_13=old;
	return;
      case XK_slash : /* song length ++ */
	xm->cur_pos_13=6;
	interface_subwin_13(i, xm, XK_Return);
	xm->cur_pos_13=old;
	return;
      case XK_backslash : /* song length -- */
	xm->cur_pos_13=7;
	interface_subwin_13(i, xm, XK_Return);
	xm->cur_pos_13=old;
	return;
      case XK_Return : /* close/open channel */
	xm->channels[xm->start_column_0+xm->cursor_column_0].in_use=0;
	xm->channels[xm->start_column_0+xm->cursor_column_0].closed^=1;
	draw_patterns(i, xm);
	return;
    }
  }

  switch((unsigned long)ks+((unsigned long)status<<16)) {
    /* horizontal moving */
    case XK_Tab :
      xm->cur_pos_0=0;
      xm->cursor_column_0++;
      if (xm->cursor_column_0==(xm->nb_channels<6 ? xm->nb_channels : 6)) {
	if (xm->start_column_0+xm->cursor_column_0>=xm->nb_channels) {
	  xm->cursor_column_0=0;
	  xm->start_column_0=0;
	} else {
	  xm->start_column_0++;
	  xm->cursor_column_0--;
	}
      }
      draw_patterns(i, xm);
      break;
    case XK_Tab+(ControlMask<<16) : /* control tab, awful. Is this portable ? */
      if (xm->cur_pos_0>0) {
	xm->cur_pos_0=0;
	draw_patterns(i, xm);
	break;
      }
      if (xm->cur_pos_0<0)
	xm->cur_pos_0=7;
      xm->cursor_column_0--;
      if (xm->cursor_column_0==-1) {
	if (xm->start_column_0==0) {
	  xm->cursor_column_0=xm->nb_channels>=6 ? 5 : xm->nb_channels-1;
	  xm->start_column_0=xm->nb_channels>6 ? xm->nb_channels-6 : 0;
	} else {
	  xm->start_column_0--;
	  xm->cursor_column_0++;
	}
      }
      draw_patterns(i, xm);
      break;
    case XK_Right : /* Why remake an already existing code ? and i like recursive-stuff */
      xm->cur_pos_0++;
      if (xm->cur_pos_0==8) {
	status=0;
        interface_subwin_0(i, xm, XK_Tab);
      } else
	draw_patterns(i, xm);
      break;
    case XK_Left : /* same remark as above */
      xm->cur_pos_0--;
      if (xm->cur_pos_0==-1) {
	status=ControlMask;
        interface_subwin_0(i, xm, XK_Tab);
      } else
	draw_patterns(i, xm);
      break;
    case XK_Home :
      if (!xm->cur_pos_0 && !xm->start_column_0 && !xm->cursor_column_0)
	break;
      xm->cur_pos_0=0;
      xm->start_column_0=0;
      xm->cursor_column_0=0;
      draw_patterns(i, xm);
      break;
    case XK_End :
      if (xm->cur_pos_0==7 && xm->start_column_0==(xm->nb_channels<=6 ? 0 : xm->nb_channels-6) &&
	  xm->cursor_column_0==(xm->nb_channels<6 ? xm->nb_channels-1 : 5))
	break;
      xm->cur_pos_0=7;
      xm->start_column_0=xm->nb_channels<=6 ? 0 : xm->nb_channels-6;
      xm->cursor_column_0=xm->nb_channels<6 ? xm->nb_channels-1 : 5;
      draw_patterns(i, xm);
      break;
    /* vertical moving */
    case XK_Down : /* next line */
      xm->current_line++;
      if (xm->current_line==xm->patterns_nb_rows[xm->patterns_order[xm->current_pattern]]) {
	xm->current_line--;
	break;
      }
      close_all_channels(xm);
      xm->current_line--;
      xm->speed=32768;
      xm->to_handle=new_line(xm);
      xm->new_line=xm->new_pattern=0;
      draw_patterns(i, xm);
      break;
    case XK_Up : /* previous line */
      xm->current_line--;
      if (xm->current_line==-1) {
	xm->current_line++;
	break;
      }
      close_all_channels(xm);
      xm->current_line--;
      xm->speed=32768;
      xm->to_handle=new_line(xm);
      xm->new_line=xm->new_pattern=0;
      draw_patterns(i, xm);
      break;
    case XK_Page_Down : /* line + 8 */
      if (xm->current_line==xm->patterns_nb_rows[xm->patterns_order[xm->current_pattern]]-1)
	break;
      xm->current_line+=8;
      if (xm->current_line>=xm->patterns_nb_rows[xm->patterns_order[xm->current_pattern]])
	xm->current_line=xm->patterns_nb_rows[xm->patterns_order[xm->current_pattern]]-1;
      close_all_channels(xm);
      xm->current_line--;
      xm->speed=32768;
      xm->to_handle=new_line(xm);
      xm->new_line=xm->new_pattern=0;
      draw_patterns(i, xm);
      break;
    case XK_Page_Up : /* line - 8 */
      if (xm->current_line==0)
	break;
      xm->current_line-=8;
      if (xm->current_line<0)
	xm->current_line=0;
      close_all_channels(xm);
      xm->current_line--;
      xm->speed=32768;
      xm->to_handle=new_line(xm);
      xm->new_line=xm->new_pattern=0;
      draw_patterns(i, xm);
      break;
    case XK_Page_Down+(ControlMask<<16) : /* next pattern */
      xm->current_pattern++;
      if (xm->current_pattern==xm->song_length) {
	XBell(i->X_ecran, 0);
	xm->current_pattern--;
	break;
      }
      xm->current_line=0;
      close_all_channels(xm);
      xm->current_line--;
      xm->speed=32768;
      xm->to_handle=new_line(xm);
      xm->new_line=xm->new_pattern=0;
      draw_patterns(i, xm);
      draw_patterns_order(i, xm);
      break;
    case XK_Page_Up+(ControlMask<<16) : /* previous pattern */
      xm->current_pattern--;
      if (xm->current_pattern==-1) {
	XBell(i->X_ecran, 0);
	xm->current_pattern++;
	break;
      }
      xm->current_line=0;
      close_all_channels(xm);
      xm->current_line--;
      xm->speed=32768;
      xm->to_handle=new_line(xm);
      xm->new_line=xm->new_pattern=0;
      draw_patterns(i, xm);
      draw_patterns_order(i, xm);
      break;
    /* insert/delete in the current pattern */
    case XK_Insert : { /* insert a note to the current position (push all down from 1 line, forget the last line
			* of the pattern) */
      int l, size=xm->patterns_nb_rows[(int)xm->patterns_order[xm->current_pattern]];
      note *n=xm->patterns[(int)xm->patterns_order[xm->current_pattern]]+size*(xm->start_column_0+xm->cursor_column_0);
      for (l=size-2; l>=xm->current_line; l--)
	memcpy(&n[l+1], &n[l], sizeof(note));
      memset(&n[xm->current_line], -1, sizeof(note));
      n[xm->current_line].volume=0;
      n[xm->current_line].effect_parameter=0;
      close_all_channels(xm);
      xm->current_line--;
      xm->speed=32768;
      xm->to_handle=new_line(xm);
      xm->new_line=xm->new_pattern=0;
      draw_patterns(i, xm);
      break;
    }
    case XK_Insert+(Mod1Mask<<16) : { /* insert a full line (like insert but for the whole pattern) */
      int l, size=xm->patterns_nb_rows[(int)xm->patterns_order[xm->current_pattern]];
      note *n=xm->patterns[(int)xm->patterns_order[xm->current_pattern]];
      int s;
      for (s=0; s<xm->nb_channels; s++) {
	for (l=size-2; l>=xm->current_line; l--)
	  memcpy(&n[l+1], &n[l], sizeof(note));
	memset(&n[xm->current_line], -1, sizeof(note));
	n[xm->current_line].volume=0;
	n[xm->current_line].effect_parameter=0;
	n+=size;
      }
      close_all_channels(xm);
      xm->current_line--;
      xm->speed=32768;
      xm->to_handle=new_line(xm);
      xm->new_line=xm->new_pattern=0;
      draw_patterns(i, xm);
      break;
    }
    case XK_Insert+((ShiftMask|Mod1Mask)<<16) : { /* expand (ie insert a line on two in the pattern, forget what is too big)
						   * (possibility taken from ft2) */
      /* not a very efficiant code, but easy to understand, and by the way, it's not so cpu-consuming */
      int old;
      int size=xm->patterns_nb_rows[(int)xm->patterns_order[xm->current_pattern]];
      for (old=1; old<size; old+=2) {
	note *n=xm->patterns[(int)xm->patterns_order[xm->current_pattern]];
	int s, l;
	for (s=0; s<xm->nb_channels; s++) {
	  for (l=size-2; l>=old; l--)
	    memcpy(&n[l+1], &n[l], sizeof(note));
	  memset(&n[old], -1, sizeof(note));
	  n[old].volume=0;
	  n[old].effect_parameter=0;
	  n+=size;
	}
      }
      close_all_channels(xm);
      xm->current_line--;
      xm->speed=32768;
      xm->to_handle=new_line(xm);
      xm->new_line=xm->new_pattern=0;
      draw_patterns(i, xm);
      break;
    }
    case XK_BackSpace : { /* like insert, but in the other way (and we go up one pattern) */
      int l, size;
      note *n;
      if (xm->current_line==0) {
	XBell(i->X_ecran, 0);
	break;
      }
      xm->current_line--;
      size=xm->patterns_nb_rows[(int)xm->patterns_order[xm->current_pattern]];
      n=xm->patterns[(int)xm->patterns_order[xm->current_pattern]]+size*(xm->start_column_0+xm->cursor_column_0);
      for (l=xm->current_line; l<=size-2; l++)
	memcpy(&n[l], &n[l+1], sizeof(note));
      memset(&n[size-1], -1, sizeof(note));
      n[size-1].volume=0;
      n[size-1].effect_parameter=0;
      close_all_channels(xm);
      xm->current_line--;
      xm->speed=32768;
      xm->to_handle=new_line(xm);
      xm->new_line=xm->new_pattern=0;
      draw_patterns(i, xm);
      break;
    }
    case XK_BackSpace+(Mod1Mask<<16) : { /* like alt+insert, in the other way (and go up one line) */
      int l, size;
      note *n;
      int s;
      if (xm->current_line==0) {
	XBell(i->X_ecran, 0);
	break;
      }
      xm->current_line--;
      size=xm->patterns_nb_rows[(int)xm->patterns_order[xm->current_pattern]];
      n=xm->patterns[(int)xm->patterns_order[xm->current_pattern]];
      for (s=0; s<xm->nb_channels; s++) {
	for (l=xm->current_line; l<=size-2; l++)
	  memcpy(&n[l], &n[l+1], sizeof(note));
	memset(&n[size-1], -1, sizeof(note));
	n[size-1].volume=0;
	n[size-1].effect_parameter=0;
	n+=size;
      }
      close_all_channels(xm);
      xm->current_line--;
      xm->speed=32768;
      xm->to_handle=new_line(xm);
      xm->new_line=xm->new_pattern=0;
      draw_patterns(i, xm);
      break;
    }
    case XK_BackSpace+((ShiftMask|Mod1Mask)<<16) : { /* shrink (opposite of expand) */
      int size=xm->patterns_nb_rows[(int)xm->patterns_order[xm->current_pattern]];
      note *n=xm->patterns[(int)xm->patterns_order[xm->current_pattern]];
      int s, l, frontier=(size-1)/2;
      for (s=0; s<xm->nb_channels; s++) {
	for (l=1; l<=frontier; l++)
	  memcpy(&n[l], &n[l*2], sizeof(note));
	for (l=frontier+1; l<size; l++) {
	  memset(&n[l], -1, sizeof(note));
	  n[l].volume=0;
	  n[l].effect_parameter=0;
	}
	n+=size;
      }
      close_all_channels(xm);
      xm->current_line--;
      xm->speed=32768;
      xm->to_handle=new_line(xm);
      xm->new_line=xm->new_pattern=0;
      draw_patterns(i, xm);
      break;
    }
    case XK_Delete : { /* delete what is under the cursor */
      note *n=xm->patterns[(int)xm->patterns_order[xm->current_pattern]]+
	xm->patterns_nb_rows[(int)xm->patterns_order[xm->current_pattern]]*(xm->start_column_0+xm->cursor_column_0)+
	xm->current_line;
      switch(xm->cur_pos_0) {
	case 0 : /* delete the note */
	  if (n->note==0xff)
	    break;
	  n->note=0xff;
	  close_all_channels(xm);
	  xm->current_line--;
	  xm->speed=32768;
	  xm->to_handle=new_line(xm);
	  xm->new_line=xm->new_pattern=0;
	  draw_patterns(i, xm);
	  break;
	case 1 : /* delete the instrument */
	case 2 :
	  if (n->instrument==-1)
	    break;
	  n->instrument=-1;
	  close_all_channels(xm);
	  xm->current_line--;
	  xm->speed=32768;
	  xm->to_handle=new_line(xm);
	  xm->new_line=xm->new_pattern=0;
	  draw_patterns(i, xm);
	  break;
	case 3 : /* delete the volume */
	case 4 :
	  if (n->volume==0)
	    break;
	  n->volume=0;
	  close_all_channels(xm);
	  xm->current_line--;
	  xm->speed=32768;
	  xm->to_handle=new_line(xm);
	  xm->new_line=xm->new_pattern=0;
	  draw_patterns(i, xm);
	  break;
	case 5 : /* delete the effect */
	case 6 :
	case 7 :
	  if (n->effect_type==-1)
	    break;
	  n->effect_type=-1;
	  n->effect_parameter=0;
	  close_all_channels(xm);
	  xm->current_line--;
	  xm->speed=32768;
	  xm->to_handle=new_line(xm);
	  xm->new_line=xm->new_pattern=0;
	  draw_patterns(i, xm);
	  break;
      }
      break;
    }
    case XK_Delete+(ControlMask<<16) : { /* delete the whole note */
      note *n=xm->patterns[(int)xm->patterns_order[xm->current_pattern]]+
	xm->patterns_nb_rows[(int)xm->patterns_order[xm->current_pattern]]*(xm->start_column_0+xm->cursor_column_0)+
	xm->current_line;
      if (n->note==0xff && n->instrument==-1 && n->volume==0 && n->effect_type==-1)
	break;
      n->note=0xff;
      n->instrument=-1;
      n->volume=0;
      n->effect_type=-1;
      n->effect_parameter=0;
      close_all_channels(xm);
      xm->current_line--;
      xm->speed=32768;
      xm->to_handle=new_line(xm);
      xm->new_line=xm->new_pattern=0;
      draw_patterns(i, xm);
      break;
    }
    /* cut-buffer manipulation */
    case XK_Insert+(ShiftMask<<16) : { /* shift+ins = copy cut-buffer to current position (the fitting part of it) */
      note *to, *from;
      int column, nb_lines;
      if (xm->cut_buffer_nb_lines==0 || xm->cut_buffer_nb_columns==0) {
	XBell(i->X_ecran, 0);
	break;
      }
      xm->current_selection_pattern=xm->patterns_order[xm->current_pattern];
      xm->current_selection_start_line=xm->current_line;
      xm->current_selection_start_column=xm->start_column_0+xm->cursor_column_0;
      to=xm->patterns[xm->current_selection_pattern];
      to+=(xm->current_selection_start_column)*xm->patterns_nb_rows[xm->current_selection_pattern];
      to+=xm->current_selection_start_line;
      from=xm->cut_buffer;
      nb_lines=xm->cut_buffer_nb_lines;
      if (nb_lines>xm->patterns_nb_rows[xm->current_selection_pattern]-xm->current_line)
	nb_lines=xm->patterns_nb_rows[xm->current_selection_pattern]-xm->current_line;
      xm->current_selection_nb_lines=nb_lines;
      xm->current_selection_nb_columns=xm->cut_buffer_nb_columns;
      if (xm->current_selection_nb_columns>xm->nb_channels-xm->current_selection_start_column)
	xm->current_selection_nb_columns=xm->nb_channels-xm->current_selection_start_column;
      for (column=0; column<xm->current_selection_nb_columns; column++) {
	memcpy(to, from, nb_lines*sizeof(note));
	from+=256;
	to+=xm->patterns_nb_rows[xm->current_selection_pattern];
      }
      close_all_channels(xm);
      xm->current_line--;
      xm->speed=32768;
      xm->to_handle=new_line(xm);
      xm->new_line=xm->new_pattern=0;
      draw_patterns(i, xm);
      break;
    }
    case XK_Insert+(ControlMask<<16) : { /* control+insert = copy the current selection into the cut-buffer */
      note *from, *to;
      int column, nb_lines;
      if (xm->current_selection_pattern!=xm->patterns_order[xm->current_pattern]) {
	XBell(i->X_ecran, 0);
	break;
      }
      from=xm->patterns[xm->current_selection_pattern];
      from+=(xm->current_selection_start_column)*xm->patterns_nb_rows[xm->current_selection_pattern];
      from+=xm->current_selection_start_line;
      to=xm->cut_buffer;
      nb_lines=xm->current_selection_nb_lines;
      for (column=0; column<xm->current_selection_nb_columns; column++) {
	memcpy(to, from, nb_lines*sizeof(note));
	to+=256;
	from+=xm->patterns_nb_rows[xm->current_selection_pattern];
      }
      xm->cut_buffer_nb_lines=xm->current_selection_nb_lines;
      xm->cut_buffer_nb_columns=xm->current_selection_nb_columns;
      break;
    }
    /* the following fun are like a move, but deal with selection */
    case XK_Tab+(ShiftMask<<16) :
    case XK_Right+(ShiftMask<<16) : { /* will be like a tab */
      int column=xm->cursor_column_0+xm->start_column_0;
      if (column==xm->nb_channels-1) {
	XBell(i->X_ecran, 0);
	break;
      }
      status=0;
      /* 6 cases : sel is in another win, we are up-right, down-right, up left, down left or somewhere-else */
      /* first, another window */
      if (xm->current_selection_pattern==xm->patterns_order[xm->current_pattern]) {
	/* that's the same window */
	/* let's test right */
	if (column==xm->current_selection_start_column+xm->current_selection_nb_columns-1) {
	  if (xm->current_line==xm->current_selection_start_line
	      || xm->current_line==xm->current_selection_start_line+xm->current_selection_nb_lines-1) {
	    xm->current_selection_nb_columns++;
	    interface_subwin_0(i, xm, XK_Tab);
	    break;
	  }
	}
	/* now left */
	if (column==xm->current_selection_start_column) {
	  if (xm->current_line==xm->current_selection_start_line
	      || xm->current_line==xm->current_selection_start_line+xm->current_selection_nb_lines-1) {
	    xm->current_selection_nb_columns--;
	    xm->current_selection_start_column++;
	    interface_subwin_0(i, xm, XK_Tab);
	    break;
	  }
	}
      }
      /* so, it's another window or anywhere, so start a new selection */
      xm->current_selection_pattern=xm->patterns_order[xm->current_pattern];
      xm->current_selection_nb_lines=1;
      xm->current_selection_nb_columns=2;
      xm->current_selection_start_line=xm->current_line;
      xm->current_selection_start_column=column;
      interface_subwin_0(i, xm, XK_Tab);
      break;
    }
    case XK_Tab+((ControlMask|ShiftMask)<<16) :
    case XK_Left+(ShiftMask<<16) : { /* will be like a control+tab */
      int column=xm->cursor_column_0+xm->start_column_0;
      if (column==0) {
	XBell(i->X_ecran, 0);
	break;
      }
      xm->cur_pos_0=0;
      status=ControlMask;
      if (xm->current_selection_pattern==xm->patterns_order[xm->current_pattern]) {
	if (column==xm->current_selection_start_column) {
	  if (xm->current_line==xm->current_selection_start_line
	      || xm->current_line==xm->current_selection_start_line+xm->current_selection_nb_lines-1) {
	    xm->current_selection_nb_columns++;
	    xm->current_selection_start_column--;
	    interface_subwin_0(i, xm, XK_Tab);
	    break;
	  }
	}
	if (column==xm->current_selection_start_column+xm->current_selection_nb_columns-1) {
	  if (xm->current_line==xm->current_selection_start_line
	      || xm->current_line==xm->current_selection_start_line+xm->current_selection_nb_lines-1) {
	    xm->current_selection_nb_columns--;
	    interface_subwin_0(i, xm, XK_Tab);
	    break;
	  }
	}
      }
      xm->current_selection_pattern=xm->patterns_order[xm->current_pattern];
      xm->current_selection_nb_lines=1;
      xm->current_selection_nb_columns=2;
      xm->current_selection_start_line=xm->current_line;
      xm->current_selection_start_column=column-1;
      interface_subwin_0(i, xm, XK_Tab);
      break;
    }
    case XK_Down+(ShiftMask<<16) : {
      int column=xm->cursor_column_0+xm->start_column_0;
      if (xm->current_line==xm->patterns_nb_rows[xm->patterns_order[xm->current_pattern]]-1) {
	XBell(i->X_ecran, 0);
	break;
      }
      status=0;
      if (xm->current_selection_pattern==xm->patterns_order[xm->current_pattern]) {
	/* test down */
	if (xm->current_line==xm->current_selection_start_line+xm->current_selection_nb_lines-1) {
	  if (column==xm->current_selection_start_column
	      || column==xm->current_selection_start_column+xm->current_selection_nb_columns-1) {
	    xm->current_selection_nb_lines++;
	    interface_subwin_0(i, xm, XK_Down);
	    break;
	  }
	}
	/* now up */
	if (xm->current_line==xm->current_selection_start_line) {
	  if (column==xm->current_selection_start_column
	      || column==xm->current_selection_start_column+xm->current_selection_nb_columns-1) {
	    xm->current_selection_nb_lines--;
	    xm->current_selection_start_line++;
	    interface_subwin_0(i, xm, XK_Down);
	    break;
	  }
	}
      }
      xm->current_selection_pattern=xm->patterns_order[xm->current_pattern];
      xm->current_selection_nb_lines=2;
      xm->current_selection_nb_columns=1;
      xm->current_selection_start_line=xm->current_line;
      xm->current_selection_start_column=column;
      interface_subwin_0(i, xm, XK_Down);
      break;
    }
    case XK_Up+(ShiftMask<<16) : {
      int column=xm->cursor_column_0+xm->start_column_0;
      if (xm->current_line==0) {
	XBell(i->X_ecran, 0);
	break;
      }
      status=0;
      if (xm->current_selection_pattern==xm->patterns_order[xm->current_pattern]) {
	/* test up */
	if (xm->current_line==xm->current_selection_start_line) {
	  if (column==xm->current_selection_start_column
	      || column==xm->current_selection_start_column+xm->current_selection_nb_columns-1) {
	    xm->current_selection_nb_lines++;
	    xm->current_selection_start_line--;
	    interface_subwin_0(i, xm, XK_Up);
	    break;
	  }
	}
	/* now down */
	if (xm->current_line==xm->current_selection_start_line+xm->current_selection_nb_lines-1) {
	  if (column==xm->current_selection_start_column
	      || column==xm->current_selection_start_column+xm->current_selection_nb_columns-1) {
	    xm->current_selection_nb_lines--;
	    interface_subwin_0(i, xm, XK_Up);
	    break;
	  }
	}
      }
      xm->current_selection_pattern=xm->patterns_order[xm->current_pattern];
      xm->current_selection_nb_lines=2;
      xm->current_selection_nb_columns=1;
      xm->current_selection_start_line=xm->current_line-1;
      xm->current_selection_start_column=column;
      interface_subwin_0(i, xm, XK_Up);
      break;
    }
    case XK_Page_Down+(ShiftMask<<16) : { /* line + 8 */
      int column=xm->cursor_column_0+xm->start_column_0;
      int old_line=xm->current_line;
      if (xm->current_line==xm->patterns_nb_rows[xm->patterns_order[xm->current_pattern]]-1)
	break;
      xm->current_line+=8;
      if (xm->current_line>=xm->patterns_nb_rows[xm->patterns_order[xm->current_pattern]])
	xm->current_line=xm->patterns_nb_rows[xm->patterns_order[xm->current_pattern]]-1;
      close_all_channels(xm);
      xm->current_line--;
      xm->speed=32768;
      xm->to_handle=new_line(xm);
      xm->new_line=xm->new_pattern=0;
      /* till now, it's the same that page_down, but now, handle shift option */
      /* test down left or down right */
      if (xm->current_selection_pattern==xm->patterns_order[xm->current_pattern]) {
	/* test down */
	if (old_line==xm->current_selection_start_line+xm->current_selection_nb_lines-1) {
	  if (column==xm->current_selection_start_column
	      || column==xm->current_selection_start_column+xm->current_selection_nb_columns-1) {
	    xm->current_selection_nb_lines+=xm->current_line-old_line;
	    draw_patterns(i, xm);
	    break;
	  }
	}
	if (old_line==xm->current_selection_start_line) {
	  if (column==xm->current_selection_start_column
	      || column==xm->current_selection_start_column+xm->current_selection_nb_columns-1) {
	    if (xm->current_selection_nb_lines-(xm->current_line-old_line)>0) {
	      xm->current_selection_start_line=xm->current_line;
	      xm->current_selection_nb_lines-=xm->current_line-old_line;
	    } else {
	      xm->current_selection_start_line=xm->current_selection_start_line+xm->current_selection_nb_lines;
	      xm->current_selection_nb_lines=xm->current_line-xm->current_selection_start_line+1;
	    }
	    draw_patterns(i, xm);
	    break;
	  }
	}
      }
      xm->current_selection_pattern=xm->patterns_order[xm->current_pattern];
      xm->current_selection_nb_lines=xm->current_line-old_line+1;
      xm->current_selection_nb_columns=1;
      xm->current_selection_start_line=old_line;
      xm->current_selection_start_column=column;
      draw_patterns(i, xm);
      break;
    }
    case XK_Page_Up+(ShiftMask<<16) : { /* line - 8 */
      int column=xm->cursor_column_0+xm->start_column_0;
      int old_line=xm->current_line;
      if (xm->current_line==0)
	break;
      xm->current_line-=8;
      if (xm->current_line<0)
	xm->current_line=0;
      close_all_channels(xm);
      xm->current_line--;
      xm->speed=32768;
      xm->to_handle=new_line(xm);
      xm->new_line=xm->new_pattern=0;
      if (xm->current_selection_pattern==xm->patterns_order[xm->current_pattern]) {
	/* test up */
	if (old_line==xm->current_selection_start_line) {
	  if (column==xm->current_selection_start_column
	      || column==xm->current_selection_start_column+xm->current_selection_nb_columns-1) {
	    xm->current_selection_nb_lines+=old_line-xm->current_line;
	    xm->current_selection_start_line=xm->current_line;
	    draw_patterns(i, xm);
	    break;
	  }
	}
	/* test down */
	if (old_line==xm->current_selection_start_line+xm->current_selection_nb_lines-1) {
	  if (column==xm->current_selection_start_column
	      || column==xm->current_selection_start_column+xm->current_selection_nb_columns-1) {
	    if (xm->current_selection_nb_lines-(old_line-xm->current_line)>0) {
	      xm->current_selection_nb_lines-=old_line-xm->current_line;
	    } else {
	      xm->current_selection_nb_lines=xm->current_selection_start_line-xm->current_line;
	      xm->current_selection_start_line=xm->current_line;
	    }
	    draw_patterns(i, xm);
	    break;
	  }
	}
      }
      xm->current_selection_pattern=xm->patterns_order[xm->current_pattern];
      xm->current_selection_nb_lines=old_line-xm->current_line+1;
      xm->current_selection_nb_columns=1;
      xm->current_selection_start_line=xm->current_line;
      xm->current_selection_start_column=column;
      draw_patterns(i, xm);
      break;
    }
    case XK_End+(ShiftMask<<16) : { /* shift+end */
      int column=xm->cursor_column_0+xm->start_column_0;
      if (column==xm->nb_channels-1) {
	XBell(i->X_ecran, 0);
	break;
      }
      status=0;
      if (xm->current_selection_pattern==xm->patterns_order[xm->current_pattern]) {
	/* let's test right */
	if (column==xm->current_selection_start_column+xm->current_selection_nb_columns-1) {
	  if (xm->current_line==xm->current_selection_start_line
	      || xm->current_line==xm->current_selection_start_line+xm->current_selection_nb_lines-1) {
	    xm->current_selection_nb_columns+=xm->nb_channels-column-1;
	    interface_subwin_0(i, xm, XK_End);
	    break;
	  }
	}
	/* now left */
	if (column==xm->current_selection_start_column) {
	  if (xm->current_line==xm->current_selection_start_line
	      || xm->current_line==xm->current_selection_start_line+xm->current_selection_nb_lines-1) {
	    xm->current_selection_start_column+=xm->current_selection_nb_columns-1;
	    xm->current_selection_nb_columns=xm->nb_channels-xm->current_selection_start_column;
	    interface_subwin_0(i, xm, XK_End);
	    break;
	  }
	}
      }
      xm->current_selection_pattern=xm->patterns_order[xm->current_pattern];
      xm->current_selection_nb_lines=1;
      xm->current_selection_nb_columns=xm->nb_channels-column;
      xm->current_selection_start_line=xm->current_line;
      xm->current_selection_start_column=column;
      interface_subwin_0(i, xm, XK_End);
      break;
    }
    case XK_Home+(ShiftMask<<16) : { /* shift+begin */
      int column=xm->cursor_column_0+xm->start_column_0;
      if (column==0) {
	XBell(i->X_ecran, 0);
	break;
      }
      status=0;
      if (xm->current_selection_pattern==xm->patterns_order[xm->current_pattern]) {
	/* test left */
	if (column==xm->current_selection_start_column) {
	  if (xm->current_line==xm->current_selection_start_line
	      || xm->current_line==xm->current_selection_start_line+xm->current_selection_nb_lines-1) {
	    xm->current_selection_nb_columns+=xm->current_selection_start_column;
	    xm->current_selection_start_column=0;
	    interface_subwin_0(i, xm, XK_Home);
	    break;
	  }
	}
	/* now right */
	if (column==xm->current_selection_start_column+xm->current_selection_nb_columns-1) {
	  if (xm->current_line==xm->current_selection_start_line
	      || xm->current_line==xm->current_selection_start_line+xm->current_selection_nb_lines-1) {
	    xm->current_selection_nb_columns=xm->current_selection_start_column+1;
	    xm->current_selection_start_column=0;
	    interface_subwin_0(i, xm, XK_Home);
	    break;
	  }
	}
      }
      xm->current_selection_pattern=xm->patterns_order[xm->current_pattern];
      xm->current_selection_nb_lines=1;
      xm->current_selection_nb_columns=column+1;
      xm->current_selection_start_line=xm->current_line;
      xm->current_selection_start_column=0;
      interface_subwin_0(i, xm, XK_Home);
      break;
    }
    /* entering something in the current pos. (maybe) */
    default :
      /* bored of this big switch, let's make a new function */
      insert_something(i, xm, ks);
      break;
  }
}

void interface_subwin_1(INTERFACE *i, XM *xm, KeySym ks)
{
}

void draw_default_bpm(INTERFACE *i, XM *xm)
{
  char res[10]; /* do you think there could be a buffer overflow ? who d'ya think i am !? */

  draw_box(i->X_ecran, xm->pixmap, i->context, XDD+9+6*7+5+13+3, 1+5+4+8, 7*6-4-16, 12, 3);
  sprintf(res, "%d", xm->default_bpm);
  draw_string(i->X_ecran, xm->pixmap, i->context, XDD+9+6*7+5+13+3+2+6*(3-strlen(res)),
	      1+5+4+8+10, res, i->little, 8);
  XCopyArea(i->X_ecran, xm->pixmap, xm->window, i->context, XDD+9+6*7+5+13+3, 1+5+4+8, 7*6-4-16, 12,
	    XDD+9+6*7+5+13+3, 1+5+4+8);
}

void draw_default_speed(INTERFACE *i, XM *xm)
{
  char res[10]; /* do you think there could be a buffer overflow ? who d'ya think i am !? */

  draw_box(i->X_ecran, xm->pixmap, i->context, XDD+9+6*7+5+13+3, 1+5+4+13+3+13+6+8, 7*6-4-16, 12, 3);
  sprintf(res, "%d", xm->default_tempo);
  draw_string(i->X_ecran, xm->pixmap, i->context, XDD+9+6*7+5+13+3+2+6*(3-strlen(res)),
	      39+24, res, i->little, 8);
  XCopyArea(i->X_ecran, xm->pixmap, xm->window, i->context, XDD+9+6*7+5+13+3, 1+5+4+13+3+13+6+8, 7*6-4-16, 12,
	    XDD+9+6*7+5+13+3, 1+5+4+13+3+13+6+8);
}

void interface_subwin_2(INTERFACE *i, XM *xm, KeySym ks)
{
  switch(ks) {
    case XK_Down :
      exit_subwin_2(i, xm);
      xm->cur_pos_2++;
      xm->cur_pos_2&=3;
      enter_subwin_2(i, xm);
      break;
    case XK_Up :
      exit_subwin_2(i, xm);
      xm->cur_pos_2--;
      xm->cur_pos_2&=3;
      enter_subwin_2(i, xm);
      break;
    case XK_Return :
    case XK_space :
      switch(xm->cur_pos_2) {
	case 0 :
	  if (xm->default_bpm==255) {
	    XBell(i->X_ecran, 0);
	    break;
	  }
	  xm->default_bpm++;
	  xm->bpm=xm->default_bpm;
	  draw_default_bpm(i, xm);
	  break;
	case 1 :
	  if (xm->default_bpm==32) {
	    XBell(i->X_ecran, 0);
	    break;
	  }
	  xm->default_bpm--;
	  xm->bpm=xm->default_bpm;
	  draw_default_bpm(i, xm);
	  break;
	case 2 :
	  if (xm->default_tempo>=31) {
	    XBell(i->X_ecran, 0);
	    break;
	  }
	  xm->default_tempo++;
	  xm->current_tempo=xm->default_tempo;
	  draw_default_speed(i, xm);
	  break;
	case 3 :
	  if (xm->default_tempo<=0) {
	    XBell(i->X_ecran, 0);
	    break;
	  }
	  xm->default_tempo--;
	  xm->current_tempo=xm->default_tempo;
	  draw_default_speed(i, xm);
	  break;
      }
  }
}

void interface_subwin_3(INTERFACE *i, XM *xm, KeySym ks)
{
  int len=strlen(xm->module_name);

  /* we want backspace */
  if (ks==XK_BackSpace) {
    if (len==0) {
      XBell(i->X_ecran, 0);
      return;
    }
    exit_subwin_3(i, xm);
    draw_box(i->X_ecran, xm->pixmap, i->context, 265-5-14+12+6+(len-1)*6, 29-9, 6, 11, 3);
    draw_box(i->X_ecran, xm->window, i->context, 265-5-14+12+6+(len-1)*6, 29-9, 6, 11, 3);
    xm->module_name[len-1]=0;
    enter_subwin_3(i, xm);
    return;
  }

  /* or only iso latin 1 characters */
  /* don't bell if wrong, because shift keys are given */
  if (ks < XK_space || ks > XK_ydiaeresis)
    return;

  /* ok, iso latin 1 character, let's put it at the end of the string (if allowed) */
  if (len==20) {
    XBell(i->X_ecran, 0);
    return;
  }
  exit_subwin_3(i, xm);
  /* well, i looked in X11/include/keysymdef.h and i can do it. It's not very good coding anyway, should
   * make a XLookupString or something like that, no ?
   */
  xm->module_name[len]=(char)ks;
  draw_string(i->X_ecran, xm->pixmap, i->context, 265-5-14+12+6+(len)*6, 29, &xm->module_name[len], i->little, 8);
  draw_string(i->X_ecran, xm->window, i->context, 265-5-14+12+6+(len)*6, 29, &xm->module_name[len], i->little, 8);
  enter_subwin_3(i, xm);
}

void interface_subwin_4(INTERFACE *i, XM *xm, KeySym ks)
{
  void interface_subwin_5(INTERFACE *, XM *, KeySym);
  void interface_subwin_6(INTERFACE *, XM *, KeySym);

  switch (ks) {
    case XK_Down :
      exit_subwin_4(i, xm);
      xm->cur_pos_4++;
      if (xm->cur_pos_4==6)
	xm->cur_pos_4=0;
      enter_subwin_4(i, xm);
      break;
    case XK_Up :
      exit_subwin_4(i, xm);
      xm->cur_pos_4--;
      if (xm->cur_pos_4==-1)
	xm->cur_pos_4=5;
      enter_subwin_4(i, xm);
      break;
    case XK_Return :
    case XK_space :
      switch(xm->cur_pos_4) {
	case 0 :
	  interface_subwin_5(i, xm, XK_Page_Up);
	  break;
	case 1 :
	  interface_subwin_5(i, xm, XK_Up);
	  break;
	case 2 :
	  interface_subwin_5(i, xm, XK_Down);
	  break;
	case 3 :
	  interface_subwin_5(i, xm, XK_Page_Down);
	  break;
	case 4 :
	  interface_subwin_6(i, xm, XK_Up);
	  break;
	case 5 :
	  interface_subwin_6(i, xm, XK_Down);
	  break;
      }
      break;
  }
}

void draw_inst_current_line(INTERFACE *i, XM *xm, unsigned long col)
{
  instrument *inst;
  char res[30];

  draw_box(i->X_ecran, xm->pixmap, i->context, 138+294-1, 22+xm->cur_pos_5*12-8, 6*26+4-1, 10, col);
  draw_box(i->X_ecran, xm->window, i->context, 138+294-1, 22+xm->cur_pos_5*12-8, 6*26+4-1, 10, col);
  inst=xm->instruments[xm->start_5+xm->cur_pos_5];
  sprintf(res, "%2.2X  ", (unsigned char)(xm->cur_pos_5+xm->start_5+1));
  if (inst)
    sprintf(res+4, inst->name);
  draw_string(i->X_ecran, xm->pixmap, i->context, 138+294, 22+xm->cur_pos_5*12, res, i->little, 8);
  draw_string(i->X_ecran, xm->window, i->context, 138+294, 22+xm->cur_pos_5*12, res, i->little, 8);
}

void draw_inst_all_lines(INTERFACE *i, XM *xm)
{
  instrument *inst;
  char res[30];
  int in;

  draw_box(i->X_ecran, xm->pixmap, i->context, 138+294-1, 22-8, 6*26+4-1, 101-4, 6);
  draw_box(i->X_ecran, xm->pixmap, i->context, 138+294-1, 22+xm->cur_pos_5*12-8, 6*26+4-1, 10, 3);
  for (in=0; in<8; in++) {
    inst=xm->instruments[xm->start_5+in];
    sprintf(res, "%2.2X  ", (unsigned char)(in+xm->start_5+1));
    if (inst)
      sprintf(res+4, inst->name);
    draw_string(i->X_ecran, xm->pixmap, i->context, 138+294, 22+in*12, res, i->little, 8);
  }
  XCopyArea(i->X_ecran, xm->pixmap, xm->window, i->context, 138+294-1, 22-8, 6*26+4-1, 101-4, 138+294-1, 22-8);
}

void draw_sample_current_line(INTERFACE *i, XM *xm, unsigned long col)
{
  instrument *inst=xm->instruments[xm->start_5+xm->cur_pos_5];
  char res[30];

  draw_box(i->X_ecran, xm->pixmap, i->context, 138+294-1, 10+20+8*12+10+xm->cur_pos_6*12-8, 6*26+4-1, 10, col);
  draw_box(i->X_ecran, xm->window, i->context, 138+294-1, 10+20+8*12+10+xm->cur_pos_6*12-8, 6*26+4-1, 10, col);
  sprintf(res, "%2.2X  ", (unsigned char)(xm->cur_pos_6+xm->start_6+1));
  if (inst)
    sprintf(res+4, inst->sample_headers[xm->cur_pos_6+xm->start_6].sample_name);
  draw_string(i->X_ecran, xm->pixmap, i->context, 138+294, 10+20+8*12+10+xm->cur_pos_6*12, res, i->little, 8);
  draw_string(i->X_ecran, xm->window, i->context, 138+294, 10+20+8*12+10+xm->cur_pos_6*12, res, i->little, 8);
}

void draw_sample_all_lines(INTERFACE *i, XM *xm)
{
  instrument *inst=xm->instruments[xm->start_5+xm->cur_pos_5];
  char res[30];
  int in;

  draw_box(i->X_ecran, xm->pixmap, i->context, 138+294-1, 10+20+8*12+10-8, 6*26+4-1, 53-4, 6);
  draw_box(i->X_ecran, xm->pixmap, i->context, 138+294-1, 10+20+8*12+10+xm->cur_pos_6*12-8, 6*26+4-1, 10, 3);
  for (in=0; in<4; in++) {
    sprintf(res, "%2.2X  ", (unsigned char)(in+xm->start_6+1));
    if (inst)
      sprintf(res+4, inst->sample_headers[xm->start_6+in].sample_name);
    draw_string(i->X_ecran, xm->pixmap, i->context, 138+294, 10+20+8*12+10+in*12, res, i->little, 8);
  }
  XCopyArea(i->X_ecran, xm->pixmap, xm->window, i->context, 138+294-1, 10+20+8*12+10-8, 6*26+4-1, 53-4,
	    138+294-1, 10+20+8*12+10-8);
}

void interface_subwin_5(INTERFACE *i, XM *xm, KeySym ks)
{
  instrument *inst;
  int a;

  /* is it a iso-latin 1 one ? */
  if (ks>= XK_space && ks<=XK_ydiaeresis) {
    if (!(inst=xm->instruments[xm->start_5+xm->cur_pos_5])) {
      sample dum;
      int i;
      if (!(xm->instruments[xm->start_5+xm->cur_pos_5]=(instrument *)malloc(sizeof(instrument)))) {
	perror("sub_interface.interface_subwin_5");
	return;
      }
      inst=xm->instruments[xm->start_5+xm->cur_pos_5];
      memset(inst, 0, sizeof(instrument));
      memset(&dum, 0, sizeof(sample));
      dum.sample_volume=0x40;
      dum.sample_panning=0x80;
      for (i=0; i<16; i++)
	inst->sample_headers[i]=dum;
    }

    a=strlen(inst->name);
    if (a==22) {
      XBell(i->X_ecran, 0);
      return;
    }

    exit_subwin_5(i, xm);
    inst->name[a]=(char)ks;
    draw_string(i->X_ecran, xm->pixmap, i->context, 432+a*6+4*6, 22+xm->cur_pos_5*12, &inst->name[a], i->little, 8);
    draw_string(i->X_ecran, xm->window, i->context, 432+a*6+4*6, 22+xm->cur_pos_5*12, &inst->name[a], i->little, 8);
    enter_subwin_5(i, xm);
    return;
  }

  /* or a back-space */
  if (ks==XK_BackSpace) {
    if (!(inst=xm->instruments[xm->start_5+xm->cur_pos_5])) {
      XBell(i->X_ecran, 0);
      return;
    }

    a=strlen(inst->name);
    if (a==0) {
      XBell(i->X_ecran, 0);
      return;
    }

    exit_subwin_5(i, xm);
    a--;
    draw_box(i->X_ecran, xm->pixmap, i->context, 138+294+a*6+4*6, 22+xm->cur_pos_5*12-8, 6, 10, 3);
    draw_box(i->X_ecran, xm->window, i->context, 138+294+a*6+4*6, 22+xm->cur_pos_5*12-8, 6, 10, 3);
    draw_line(i->X_ecran, xm->pixmap, i->context, 138+294+a*6+4*6, 22+xm->cur_pos_5*12-8-1,
	      138+294+a*6+4*6+6, 22+xm->cur_pos_5*12-8-1, 6);
    draw_line(i->X_ecran, xm->window, i->context, 138+294+a*6+4*6, 22+xm->cur_pos_5*12-8-1,
	      138+294+a*6+4*6+6, 22+xm->cur_pos_5*12-8-1, 6);
    inst->name[a]=0;
    enter_subwin_5(i, xm);
    return;
  }

  /* or an arrow */
  switch (ks) {
    case XK_Down :
      if (xm->cur_pos_5+xm->start_5==127)
	break;
      exit_subwin_5(i, xm);
      if (xm->cur_pos_5==7) {
	xm->cur_pos_5=0;
	xm->start_5+=8;
	draw_inst_all_lines(i, xm);
	draw_sample_all_lines(i, xm);
      } else {
	draw_inst_current_line(i, xm, 6);
	xm->cur_pos_5++;
	draw_inst_current_line(i, xm, 3);
	draw_sample_all_lines(i, xm);
      }
      enter_subwin_5(i, xm);
      break;
    case XK_Up :
      if (xm->cur_pos_5+xm->start_5==0)
	break;
      exit_subwin_5(i, xm);
      if (xm->cur_pos_5==0) {
	xm->cur_pos_5=7;
	xm->start_5-=8;
	draw_inst_all_lines(i, xm);
	draw_sample_all_lines(i, xm);
      } else {
	draw_inst_current_line(i, xm, 6);
	xm->cur_pos_5--;
	draw_inst_current_line(i, xm, 3);
	draw_sample_all_lines(i, xm);
      }
      enter_subwin_5(i, xm);
      break;
    case XK_Page_Down :
      if (xm->start_5==0x78)
	break;
      exit_subwin_5(i, xm);
      xm->start_5+=8;
      draw_inst_all_lines(i, xm);
      draw_sample_all_lines(i, xm);
      enter_subwin_5(i, xm);
      break;
    case XK_Page_Up :
      if (xm->start_5==0)
	break;
      exit_subwin_5(i, xm);
      xm->start_5-=8;
      draw_inst_all_lines(i, xm);
      draw_sample_all_lines(i, xm);
      enter_subwin_5(i, xm);
      break;
  }
}

/* almost the same than above. */
void interface_subwin_6(INTERFACE *i, XM *xm, KeySym ks)
{
  instrument *inst;
  int a;

  if (ks>= XK_space && ks<=XK_ydiaeresis) {
    if (!(inst=xm->instruments[xm->start_5+xm->cur_pos_5])) {
      sample dum;
      int i;
      if (!(xm->instruments[xm->start_5+xm->cur_pos_5]=(instrument *)malloc(sizeof(instrument)))) {
	perror("sub_interface.interface_subwin_6");
	return;
      }
      inst=xm->instruments[xm->start_5+xm->cur_pos_5];
      memset(inst, 0, sizeof(instrument));
      memset(&dum, 0, sizeof(sample));
      dum.sample_volume=0x40;
      dum.sample_panning=0x80;
      for (i=0; i<16; i++)
	inst->sample_headers[i]=dum;
    }

    a=strlen(inst->sample_headers[xm->start_6+xm->cur_pos_6].sample_name);
    if (a==22) {
      XBell(i->X_ecran, 0);
      return;
    }

    exit_subwin_6(i, xm);
    inst->sample_headers[xm->start_6+xm->cur_pos_6].sample_name[a]=(char)ks;
    draw_string(i->X_ecran, xm->pixmap, i->context, 432+a*6+4*6, 10+20+8*12+10+xm->cur_pos_6*12,
		&inst->sample_headers[xm->start_6+xm->cur_pos_6].sample_name[a], i->little, 8);
    draw_string(i->X_ecran, xm->window, i->context, 432+a*6+4*6, 10+20+8*12+10+xm->cur_pos_6*12,
		&inst->sample_headers[xm->start_6+xm->cur_pos_6].sample_name[a], i->little, 8);
    enter_subwin_6(i, xm);
    return;
  }

  if (ks==XK_BackSpace) {
    if (!(inst=xm->instruments[xm->start_5+xm->cur_pos_5])) {
      XBell(i->X_ecran, 0);
      return;
    }

    a=strlen(inst->sample_headers[xm->start_6+xm->cur_pos_6].sample_name);
    if (a==0) {
      XBell(i->X_ecran, 0);
      return;
    }

    exit_subwin_6(i, xm);
    a--;
    draw_box(i->X_ecran, xm->pixmap, i->context, 138+294+a*6+4*6, 10+20+8*12+10+xm->cur_pos_6*12-8, 6, 10, 3);
    draw_box(i->X_ecran, xm->window, i->context, 138+294+a*6+4*6, 10+20+8*12+10+xm->cur_pos_6*12-8, 6, 10, 3);
    draw_line(i->X_ecran, xm->pixmap, i->context, 138+294+a*6+4*6, 10+20+8*12+10+xm->cur_pos_6*12-8-1,
	      138+294+a*6+4*6+6, 10+20+8*12+10+xm->cur_pos_6*12-8-1, 6);
    draw_line(i->X_ecran, xm->window, i->context, 138+294+a*6+4*6, 10+20+8*12+10+xm->cur_pos_6*12-8-1,
	      138+294+a*6+4*6+6, 10+20+8*12+10+xm->cur_pos_6*12-8-1, 6);
    inst->sample_headers[xm->start_6+xm->cur_pos_6].sample_name[a]=0;
    enter_subwin_6(i, xm);
    return;
  }

  switch (ks) {
    case XK_Down :
      if (xm->cur_pos_6+xm->start_6==15)
	break;
      exit_subwin_6(i, xm);
      if (xm->cur_pos_6==3) {
	xm->cur_pos_6=0;
	xm->start_6+=4;
	draw_sample_all_lines(i, xm);
      } else {
	draw_sample_current_line(i, xm, 6);
	xm->cur_pos_6++;
	draw_sample_current_line(i, xm, 3);
      }
      enter_subwin_6(i, xm);
      break;
    case XK_Up :
      if (xm->cur_pos_6+xm->start_6==0)
	break;
      exit_subwin_6(i, xm);
      if (xm->cur_pos_6==0) {
	xm->cur_pos_6=3;
	xm->start_6-=4;
	draw_sample_all_lines(i, xm);
      } else {
	draw_sample_current_line(i, xm, 6);
	xm->cur_pos_6--;
	draw_sample_current_line(i, xm, 3);
      }
      enter_subwin_6(i, xm);
      break;
    case XK_Page_Down :
      if (xm->start_6==12)
	break;
      exit_subwin_6(i, xm);
      xm->start_6+=4;
      draw_sample_all_lines(i, xm);
      enter_subwin_6(i, xm);
      break;
    case XK_Page_Up :
      if (xm->start_6==0)
	break;
      exit_subwin_6(i, xm);
      xm->start_6-=4;
      draw_sample_all_lines(i, xm);
      enter_subwin_6(i, xm);
      break;
  }
}

void interface_subwin_7(INTERFACE *i, XM *xm, KeySym ks)
{
  switch(ks) {
    case XK_Left :
    case XK_Right :
      exit_subwin_7(i, xm);
      xm->cur_pos_7++;
      xm->cur_pos_7&=1;
      enter_subwin_7(i, xm);
      break;
    case XK_Return :
    case XK_space :
      switch(xm->cur_pos_7) {
	case 0 :
	  if (xm->flags&1)
	    break;
	  draw_3d_box_around(i->X_ecran, xm->pixmap, i->context, 5+6*18-5, 79+6+2, 10, 10, 3, DOWN_3D);
	  draw_3d_box_around(i->X_ecran, xm->window, i->context, 5+6*18-5, 79+6+2, 10, 10, 3, DOWN_3D);
	  draw_3d_box_around(i->X_ecran, xm->pixmap, i->context, 5+6*29-5, 79+6+2, 10, 10, 3, UP_3D);
	  draw_3d_box_around(i->X_ecran, xm->window, i->context, 5+6*29-5, 79+6+2, 10, 10, 3, UP_3D);
	  xm->flags|=1;
	  break;
	case 1 :
	  if (!xm->flags&1)
	    break;
	  draw_3d_box_around(i->X_ecran, xm->pixmap, i->context, 5+6*29-5, 79+6+2, 10, 10, 3, DOWN_3D);
	  draw_3d_box_around(i->X_ecran, xm->window, i->context, 5+6*29-5, 79+6+2, 10, 10, 3, DOWN_3D);
	  draw_3d_box_around(i->X_ecran, xm->pixmap, i->context, 5+6*18-5, 79+6+2, 10, 10, 3, UP_3D);
	  draw_3d_box_around(i->X_ecran, xm->window, i->context, 5+6*18-5, 79+6+2, 10, 10, 3, UP_3D);
	  xm->flags&=~1;
	  break;
    }
  }
}

void interface_subwin_8(INTERFACE *i, XM *xm, KeySym ks)
{
}

void interface_subwin_9(INTERFACE *i, XM *xm, KeySym ks)
{
  void up_or_down_xm(INTERFACE *, XM *, Window, int);
  static int (*save[3])(XM *, char *)={
    save_xm, save_xm, dump_wav
  };

  switch(ks) {
    case XK_Return :
    case XK_space :
      /* do you like this very "if"-code ? It was buggy, and i don't know if it is still buggy. Should switch it all... */
      if (xm->cur_pos_9!=0 || !xm->file_name)
	if (init_file_selector(i, ".") && i->file_selector.out_name) {
	  if (xm->cur_pos_9!=2) {
	    if (xm->file_name)
	      free(xm->file_name);
	    xm->file_name=strdup(i->file_selector.out_name);	/* no need to test, because it will be 0 if problem */
	  }
	}
      if (xm->cur_pos_9==2?i->file_selector.out_name:xm->file_name)
	if (!save[xm->cur_pos_9](xm, xm->cur_pos_9==2?i->file_selector.out_name:xm->file_name))
	  fprintf(stderr, "sub_interface.interface_subwin_9 error in saving %s\n",
		  xm->cur_pos_9==2?i->file_selector.out_name:xm->file_name);
	else if (xm->cur_pos_9==2) {
	  xm->to_handle=new_line(xm);
	  draw_patterns(i, xm);
	  draw_patterns_order(i, xm);
	}
      xm->mode=MOVING;
      exit_subwin_9(i, xm);
      up_or_down_xm(i, xm, xm->subwindow, UP_3D);
      break;
    case XK_Down :
      xm->cur_pos_9++;
      if (xm->cur_pos_9>2)
	xm->cur_pos_9=0;
      draw_pos_9(i, xm);
      break;
    case XK_Up :
      xm->cur_pos_9--;
      if (xm->cur_pos_9<0)
	xm->cur_pos_9=2;
      draw_pos_9(i, xm);
      break;
  }
}

void interface_subwin_10(INTERFACE *i, XM *xm, KeySym ks)
{
}

void interface_subwin_11(INTERFACE *i, XM *xm, KeySym ks)
{
}

void interface_subwin_12(INTERFACE *i, XM *xm, KeySym ks)
{
}

/* inc. the current pattern size. Always possible, test is done before to call it. */
void inc_cur_pattern_size(XM *xm)
{
  int i;
  note *n=xm->patterns[(int)xm->patterns_order[xm->current_pattern]];
  int size=xm->patterns_nb_rows[(int)xm->patterns_order[xm->current_pattern]];
  int new_size=size+1;

  if (!(n=(note *)realloc(n, xm->nb_channels*new_size*sizeof(note)))) {
    fprintf(stderr, "sub_interface.inc_cur_pattern_size error : could not realloc\n");
    return;
  }
  xm->patterns[(int)xm->patterns_order[xm->current_pattern]]=n;

  for (i=xm->nb_channels-1; i>=1; i--) {
    memmove(n+new_size*i, n+size*i, size*sizeof(note));
    memset(&(n+new_size*i)[new_size-1], -1, sizeof(note));
    (n+new_size*i)[new_size-1].volume=0;
    (n+new_size*i)[new_size-1].effect_parameter=0;
  }
  memset(&(n)[new_size-1], -1, sizeof(note));
  n[new_size-1].volume=0;
  n[new_size-1].effect_parameter=0;

  xm->patterns_nb_rows[(int)xm->patterns_order[xm->current_pattern]]=new_size;
}

/* dec. the current pattern size. Always possible, test is done before to call it. */
void dec_cur_pattern_size(XM *xm)
{
  int i;
  note *n=xm->patterns[(int)xm->patterns_order[xm->current_pattern]];
  int size=xm->patterns_nb_rows[(int)xm->patterns_order[xm->current_pattern]];
  int new_size=size-1;

  for (i=1; i<=xm->nb_channels-1; i++)
    memmove(n+new_size*i, n+size*i, size*sizeof(note));

  xm->patterns_nb_rows[(int)xm->patterns_order[xm->current_pattern]]=new_size;

  if (!(n=(note *)realloc(n, xm->nb_channels*new_size*sizeof(note)))) {
    fprintf(stderr, "sub_interface.inc_cur_pattern_size error : could not realloc\n");
    return;
  }
  xm->patterns[(int)xm->patterns_order[xm->current_pattern]]=n;

  /* deal with current selection */
  if (xm->current_selection_pattern==xm->patterns_order[xm->current_pattern]) {
    if (xm->current_selection_start_line+xm->current_selection_nb_lines-1==
	xm->patterns_nb_rows[xm->current_selection_pattern])
      xm->current_selection_nb_lines--;
    if (!xm->current_selection_nb_lines) {
      xm->current_selection_pattern=-1;
      xm->current_selection_nb_columns=0;
    }
  }
}

void interface_subwin_13(INTERFACE *i, XM *xm, KeySym ks)
{
  switch (ks) {
    case XK_Down :
      exit_subwin_13(i, xm);
      xm->cur_pos_13++;
      xm->cur_pos_13&=7;
      enter_subwin_13(i, xm);
      break;
    case XK_Up :
      exit_subwin_13(i, xm);
      xm->cur_pos_13--;
      xm->cur_pos_13&=7;
      enter_subwin_13(i, xm);
      break;
    case XK_Return :
    case XK_space :
      switch (xm->cur_pos_13) {
	case 0 : /* up patterns viewing */
	  if (xm->current_pattern==0) {
	    XBell(i->X_ecran, 0);
	    break;
	  }
	  xm->current_pattern--;
	  xm->current_line=0;
	  close_all_channels(xm);
	  xm->current_line=-1;
	  xm->speed=32768;
	  xm->to_handle=new_line(xm);
	  xm->new_line=xm->new_pattern=0; /* otherwise, main.c will redraw things, which we don't want. */
	  draw_patterns_order(i, xm);
	  draw_patterns(i, xm);
	  break;
	case 5 : /* down patterns viewing */
	  if (xm->current_pattern==xm->song_length-1) {
	    XBell(i->X_ecran, 0);
	    break;
	  }
	  xm->current_pattern++;
	  xm->current_line=0;
	  close_all_channels(xm);
	  xm->current_line=-1;
	  xm->speed=32768;
	  xm->to_handle=new_line(xm);
	  xm->new_line=xm->new_pattern=0; /* otherwise, main.c will redraw things, which we don't want. */
	  draw_patterns_order(i, xm);
	  draw_patterns(i, xm);
	  break;
	case 1 : /* pattern++ */ {
	  unsigned int a=++(xm->patterns_order[xm->current_pattern]);
	  if (!xm->patterns[a]) {
	    xm->patterns[a]=(note *)malloc(64*xm->nb_channels*sizeof(note));
	    if (!xm->patterns[a]) {
	      --(xm->patterns_order[xm->current_pattern]);
	      fprintf(stderr, "sub_interface.interface_subwin_13 : warning malloc failed\n");
	      break;
	    }
	    xm->patterns_nb_rows[a]=64;
	    memset(xm->patterns[a], 0xff, 64*xm->nb_channels*sizeof(note));
	    {
	      int i;
	      for (i=0; i<64*xm->nb_channels; i++)
		xm->patterns[a][i].volume=0,
		xm->patterns[a][i].effect_parameter=0;
	    }
	  }
	  xm->current_line=0;
	  close_all_channels(xm);
	  xm->current_line=-1;
	  xm->speed=32768;
	  xm->to_handle=new_line(xm);
	  xm->new_line=xm->new_pattern=0; /* otherwise, main.c will redraw things, which we don't want. */
	  draw_patterns_order(i, xm);
	  draw_patterns(i, xm);
	  break;
	}
	case 2 : /* pattern-- */ {
	  unsigned int a=--(xm->patterns_order[xm->current_pattern]);
	  if (!xm->patterns[a]) {
	    xm->patterns[a]=(note *)malloc(64*xm->nb_channels*sizeof(note));
	    if (!xm->patterns[a]) {
	      ++(xm->patterns_order[xm->current_pattern]);
	      fprintf(stderr, "sub_interface.interface_subwin_13 : warning malloc failed\n");
	      break;
	    }
	    xm->patterns_nb_rows[a]=64;
	    memset(xm->patterns[a], 0xff, 64*xm->nb_channels*sizeof(note));
	    {
	      int i;
	      for (i=0; i<64*xm->nb_channels; i++)
		xm->patterns[a][i].volume=0,
		xm->patterns[a][i].effect_parameter=0;
	    }
	  }
	  xm->current_line=0;
	  close_all_channels(xm);
	  xm->current_line=-1;
	  xm->speed=32768;
	  xm->to_handle=new_line(xm);
	  xm->new_line=xm->new_pattern=0; /* otherwise, main.c will redraw things, which we don't want. */
	  draw_patterns_order(i, xm);
	  draw_patterns(i, xm);
	  break;
	}
	case 3 : /* p.length++ */
	  if (xm->patterns_nb_rows[(int)xm->patterns_order[xm->current_pattern]]==256) {
	    XBell(i->X_ecran, 0);
	    break;
	  }
	  inc_cur_pattern_size(xm);
	  draw_patterns_order(i, xm);
	  draw_patterns(i, xm);
	  break;
	case 4 : /* p.length-- */
	  if (xm->patterns_nb_rows[(int)xm->patterns_order[xm->current_pattern]]==1) {
	    XBell(i->X_ecran, 0);
	    break;
	  }
	  /* take care ! maybe we take away the playing line... */
	  if (xm->current_line==xm->patterns_nb_rows[(int)xm->patterns_order[xm->current_pattern]]-1) {
	    xm->current_line--;
	    close_all_channels(xm);
	    xm->current_line--;
	    xm->speed=32768;
	    xm->to_handle=new_line(xm);
	    xm->new_line=xm->new_pattern=0; /* otherwise, main.c will redraw things, which we don't want. */
	  }
	  dec_cur_pattern_size(xm);
	  draw_patterns_order(i, xm);
	  draw_patterns(i, xm);
	  break;
	case 6 : /* song.length++ */ {
	  char res[10];

	  if (xm->song_length==256) {
	    XBell(i->X_ecran, 0);
	    break;
	  }

	  xm->song_length++;
	  draw_box(i->X_ecran, xm->pixmap, i->context, NNX+252+35-4+7*6-4+13+5, 137+41-25+16-12-10-3+8,
		   7*6-4-16, 12, 3);
	  sprintf(res, "%d", xm->song_length);
	  draw_string(i->X_ecran, xm->pixmap, i->context, NNX+252+31+7*6-4+20+6*(3-strlen(res)), 137+25,
		      res, i->little, 8);
	  XCopyArea(i->X_ecran, xm->pixmap, xm->window, i->context, NNX+252+35-4+7*6-4+13+5, 137+41-25+16-12-10-3+8,
		   7*6-4-16, 12, NNX+252+35-4+7*6-4+13+5, 137+41-25+16-12-10-3+8);
	  draw_patterns_order(i, xm);
	  break;
	}
	case 7 : /* song.length-- */ {
	  char res[10];

	  if (xm->song_length==1) {
	    XBell(i->X_ecran, 0);
	    break;
	  }

	  /* if this is the current pattern, take the one before */
	  xm->song_length--;
	  if (xm->song_length==xm->current_pattern) {
	    xm->current_pattern--;
	    xm->current_line=0;
	    close_all_channels(xm);
	    xm->current_line=-1;
	    xm->speed=32768;
	    xm->to_handle=new_line(xm);
	    xm->new_line=xm->new_pattern=0; /* otherwise, main.c will redraw things, which we don't want. */
	    draw_patterns(i, xm);
	  }
	  draw_box(i->X_ecran, xm->pixmap, i->context, NNX+252+35-4+7*6-4+13+5, 137+41-25+16-12-10-3+8,
		   7*6-4-16, 12, 3);
	  sprintf(res, "%d", xm->song_length);
	  draw_string(i->X_ecran, xm->pixmap, i->context, NNX+252+31+7*6-4+20+6*(3-strlen(res)), 137+25,
		      res, i->little, 8);
	  XCopyArea(i->X_ecran, xm->pixmap, xm->window, i->context, NNX+252+35-4+7*6-4+13+5, 137+41-25+16-12-10-3+8,
		   7*6-4-16, 12, NNX+252+35-4+7*6-4+13+5, 137+41-25+16-12-10-3+8);
	  draw_patterns_order(i, xm);
	  /* don't forget to see if the restart position is out of bounds ! */
	  if (xm->restart==xm->song_length) {
	    /* crazy code ! */
	    void interface_subwin_14(INTERFACE *, XM *, KeySym);
	    int dum=xm->cur_pos_14;
	    xm->cur_pos_14=3;
	    interface_subwin_14(i, xm, XK_Return);
	    xm->cur_pos_14=dum;
	  }
	  break;
	}
      }
      break;
  }
}

void inc_nb_channels(XM *xm)
{
  int i, j;
  int new_nb=xm->nb_channels+2;
  note *n;

  for (i=0; i<256; i++)
    if (xm->patterns[i]) {
      if (!(n=realloc(xm->patterns[i], new_nb*xm->patterns_nb_rows[i]*sizeof(note)))) {
	fprintf(stderr, "sub_interface.inc_nb_channels error : could not realloc. Structures are corrupted, save"
		" your work and restart the program. Maybe your data won't be what you expected it to be. Sorry.\n");
	return;
      }
      memset(n+(new_nb-2)*xm->patterns_nb_rows[i], -1, 2*xm->patterns_nb_rows[i]*sizeof(note));
      for(j=0; j<2*xm->patterns_nb_rows[i]; j++)
	(n+(new_nb-2)*xm->patterns_nb_rows[i])[j].volume=0,
	(n+(new_nb-2)*xm->patterns_nb_rows[i])[j].effect_parameter=0;
      xm->patterns[i]=n;
    }

  xm->nb_channels=new_nb;
}

void dec_nb_channels(XM *xm)
{
  int i;
  int new_nb=xm->nb_channels-2;
  note *n;

  for (i=0; i<256; i++)
    if (xm->patterns[i]) {
      if (!(n=realloc(xm->patterns[i], new_nb*xm->patterns_nb_rows[i]*sizeof(note)))) {
	fprintf(stderr, "sub_interface.inc_nb_channels error : could not realloc. Structures are corrupted, save"
		" your work and restart the program. Maybe your data won't be what you expected it to be. Sorry.\n");
	return;
      }
      xm->patterns[i]=n;
    }

  xm->nb_channels=new_nb;

  /* deal with current selection */
  if (xm->current_selection_pattern==xm->patterns_order[xm->current_pattern]) {
    while (xm->current_selection_nb_columns &&
	   xm->current_selection_start_column+xm->current_selection_nb_columns>xm->nb_channels)
      xm->current_selection_nb_columns--;
    if (!xm->current_selection_nb_columns) {
      xm->current_selection_nb_lines=0;
      xm->current_selection_pattern=-1;
    }
  }
}

void draw_nb_channels(INTERFACE *i, XM *xm)
{
  char res[10]; /* forget buffer overflow, it's not possible, watch the sprintfs */

  draw_box(i->X_ecran, xm->pixmap, i->context, ADX+9+6*9+5+13+3, ADY+1+5+4+8, 6*6-4-16, 12, 3);
  sprintf(res, "%d", xm->nb_channels);
  draw_string(i->X_ecran, xm->pixmap, i->context, ADX+9+6*9+5+13+3+2+6*(2-strlen(res)), ADY+1+27,
	      res, i->little, 8);
  XCopyArea(i->X_ecran, xm->pixmap, xm->window, i->context, ADX+9+6*9+5+13+3, ADY+1+5+4+8, 6*6-4-16, 12,
	    ADX+9+6*9+5+13+3, ADY+1+5+4+8);
}

void draw_restart_pos(INTERFACE *i, XM *xm)
{
  char res[10];

  draw_box(i->X_ecran, xm->pixmap, i->context, ADX+9+6*9+5+13+3, ADY+1+5+4+13+3+13+6+8-1,
	   6*6-4-16, 12, 3);
  sprintf(res, "%2.2X", (unsigned char)(xm->restart));
  draw_string(i->X_ecran, xm->pixmap, i->context, ADX+9+6*9+5+13+3+2, ADY+10+26+3+6+17, res, i->little, 8);
  XCopyArea(i->X_ecran, xm->pixmap, xm->window, i->context, ADX+9+6*9+5+13+3, ADY+1+5+4+13+3+13+6+8-1,
	    6*6-4-16, 12, ADX+9+6*9+5+13+3, ADY+1+5+4+13+3+13+6+8-1);
}

void interface_subwin_14(INTERFACE *i, XM *xm, KeySym ks)
{
  switch(ks) {
    case XK_Down :
      exit_subwin_14(i, xm);
      xm->cur_pos_14++;
      xm->cur_pos_14&=3;
      enter_subwin_14(i, xm);
      break;
    case XK_Up :
      exit_subwin_14(i, xm);
      xm->cur_pos_14--;
      xm->cur_pos_14&=3;
      enter_subwin_14(i, xm);
      break;
    case XK_Return :
    case XK_space :
      switch(xm->cur_pos_14) {
	case 0 : /* nb chan ++ */
	  if (xm->nb_channels==32)
	    break;
	  inc_nb_channels(xm);
	  draw_nb_channels(i, xm);
	  draw_patterns(i, xm);
	  break;
	case 1 : /* nb chan -- */
	  if (xm->nb_channels==2)
	    break;
	  dec_nb_channels(xm);
	  /* we could have troubles if we were editing farther than the new nb of chan, so reset all */
	  xm->start_column_0=xm->cursor_column_0=xm->cur_pos_0=0;
	  /* let's draw things */
	  draw_nb_channels(i, xm);
	  draw_patterns(i, xm);
	  /* let's close the two lates channels, they're not here anymore, so we can't keep playing them */
	  close_two_channels(xm->nb_channels, xm);
	  break;
	case 2 : /* restart pos ++ */
	  if (xm->restart==xm->song_length-1) {
	    XBell(i->X_ecran, 0);
	    break;
	  }
	  xm->restart++;
	  draw_restart_pos(i, xm);
	  break;
	case 3 : /* restart pos -- */
	  if (xm->restart==0) {
	    XBell(i->X_ecran, 0);
	    break;
	  }
	  xm->restart--;
	  draw_restart_pos(i, xm);
	  break;
      }
      break;
  }
}

void (*enter_subwin[15])(INTERFACE *, XM *)={
  enter_subwin_0,
  enter_subwin_1,
  enter_subwin_2,
  enter_subwin_3,
  enter_subwin_4,
  enter_subwin_5,
  enter_subwin_6,
  enter_subwin_7,
  enter_subwin_8,
  enter_subwin_9,
  enter_subwin_10,
  enter_subwin_11,
  enter_subwin_12,
  enter_subwin_13,
  enter_subwin_14
};

void (*exit_subwin [15])(INTERFACE *, XM *)={
  exit_subwin_0,
  exit_subwin_1,
  exit_subwin_2,
  exit_subwin_3,
  exit_subwin_4,
  exit_subwin_5,
  exit_subwin_6,
  exit_subwin_7,
  exit_subwin_8,
  exit_subwin_9,
  exit_subwin_10,
  exit_subwin_11,
  exit_subwin_12,
  exit_subwin_13,
  exit_subwin_14
};

void (*interface_subwin[15])(INTERFACE *, XM *, KeySym)={
  interface_subwin_0,
  interface_subwin_1,
  interface_subwin_2,
  interface_subwin_3,
  interface_subwin_4,
  interface_subwin_5,
  interface_subwin_6,
  interface_subwin_7,
  interface_subwin_8,
  interface_subwin_9,
  interface_subwin_10,
  interface_subwin_11,
  interface_subwin_12,
  interface_subwin_13,
  interface_subwin_14
};
