/*
 * This file is part of xsoundtrack - a sound tracker for Linux.
 * Sed - july august 1998.
 * This is total free software.
 *-------------------------------------
 */

#include "keyboard_definition.h"

#include <X11/Xlib.h>
#include <X11/keysym.h>

KeySym keyboard_down[17]={
XK_w,		/* C 0 */
XK_s,		/* Db0 */
XK_x,		/* D 0 */
XK_d,		/* Eb0 */
XK_c,		/* E 0 */
XK_v,		/* F 0 */
XK_g,		/* Fb0 */
XK_b,		/* G 0 */
XK_h,		/* Ab0 */
XK_n,		/* A 0 */
XK_j,		/* Bb0 */
XK_comma,	/* B 0 */
XK_semicolon,	/* C 1 */
XK_l,		/* Db1 */
XK_colon,	/* D 1 */
XK_m,		/* Eb1 */
XK_exclam	/* E 1 */
};

KeySym keyboard_up[20]={
XK_a,			/* C 0 */
XK_eacute,		/* Db0 */
XK_z,			/* D 0 */
XK_quotedbl,		/* Eb0 */
XK_e,			/* E 0 */
XK_r,			/* F 0 */
XK_parenleft,		/* Fb0 */
XK_t,			/* G 0 */
XK_minus,		/* Ab0 */
XK_y,			/* A 0 */
XK_egrave,		/* Bb0 */
XK_u,			/* B 0 */
XK_i,			/* C 1 */
XK_ccedilla,		/* Db1 */
XK_o,			/* D 1 */
XK_agrave,		/* Eb1 */
XK_p,			/* E 1 */
XK_dead_circumflex,	/* F 1 */
XK_equal,		/* Fb1 */
XK_dollar,		/* G 1 */
};
